Package: regutools
Title: regutools: an R package for data extraction from RegulonDB
Version: 1.22.0
Date: 2021-11-15
Authors@R: c(
    person ("Joselyn", "Chavez", email =  "joselynchavezf@gmail.com",
        role = c("aut", "cre"), comment = c(ORCID = "0000-0002-4974-4591")),
    person("Carmina", "Barberena-Jonas", email = "car.barjon@gmail.com",
        role = c("aut"), comment = c(ORCID = "0000-0001-7413-638X")),
    person(c("Jesus", "E."), "Sotelo-Fonseca", email = "jemilianosf@gmail.com",
        role = c("aut"), comment = c(ORCID = "0000-0003-1600-2396")),
    person("Jose", "Alquicira-Hernandez", email = "joseah@lcg.unam.mx",
        role = c("ctb"), comment = c(ORCID = "0000-0002-9049-7780")),
    person("Heladia", "Salgado", email = "heladia@ccg.unam.mx",
        role = c("ctb"), comment = c(ORCID = "0000-0002-3166-5801")),
    person("Leonardo", "Collado-Torres", role = c("aut"),
        email = "lcolladotor@gmail.com",
        comment = c(ORCID = "0000-0003-2140-308X")),
    person("Alejandro", "Reyes", email = "alejandro.reyes.ds@gmail.com",
        role = c("aut"), comment = c(ORCID = "0000-0001-8717-6612"))
    )
Description: RegulonDB has collected, harmonized and centralized data 
    from hundreds of experiments for nearly two decades and is considered
    a point of reference for transcriptional regulation in Escherichia coli K12. 
    Here, we present the regutools R package to facilitate programmatic 
    access to RegulonDB data in computational biology. regutools provides 
    researchers with the possibility of writing reproducible workflows 
    with automated queries to RegulonDB. The regutools package serves as
    a bridge between RegulonDB data and the Bioconductor ecosystem by 
    reusing the data structures and statistical methods powered by other 
    Bioconductor packages. We demonstrate the integration of regutools 
    with Bioconductor by analyzing transcription factor DNA binding sites 
    and transcriptional regulatory networks from RegulonDB. We anticipate 
    that regutools will serve as a useful building block in our progress
    to further our understanding of gene regulatory networks.
License: Artistic-2.0
Encoding: UTF-8
Depends: R (>= 4.0)
Imports: AnnotationDbi, AnnotationHub, Biostrings, DBI, GenomicRanges,
        Gviz, IRanges, RCy3, RSQLite, S4Vectors, methods, stats, utils,
        BiocFileCache
RoxygenNote: 7.1.1
Suggests: BiocStyle, knitr, RefManageR, rmarkdown, sessioninfo,
        testthat (>= 2.1.0), covr
URL: https://github.com/ComunidadBioInfo/regutools
BugReports: https://support.bioconductor.org/t/regutools
biocViews: GeneRegulation, GeneExpression, SystemsBiology,
        Network,NetworkInference,Visualization, Transcription
Roxygen: list(markdown = TRUE)
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/regutools
git_branch: RELEASE_3_22
git_last_commit: f94aecc
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: no
Packaged: 2025-10-30 06:01:45 UTC; biocbuild
Author: Joselyn Chavez [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-4974-4591>),
  Carmina Barberena-Jonas [aut] (ORCID:
    <https://orcid.org/0000-0001-7413-638X>),
  Jesus E. Sotelo-Fonseca [aut] (ORCID:
    <https://orcid.org/0000-0003-1600-2396>),
  Jose Alquicira-Hernandez [ctb] (ORCID:
    <https://orcid.org/0000-0002-9049-7780>),
  Heladia Salgado [ctb] (ORCID: <https://orcid.org/0000-0002-3166-5801>),
  Leonardo Collado-Torres [aut] (ORCID:
    <https://orcid.org/0000-0003-2140-308X>),
  Alejandro Reyes [aut] (ORCID: <https://orcid.org/0000-0001-8717-6612>)
Maintainer: Joselyn Chavez <joselynchavezf@gmail.com>

<!-- README.md is generated from README.Rmd. Please edit that file -->
# regutools <img src="man/figures/logo.png" align="right" width="150px"/>

<!-- badges: start -->
[![Lifecycle: stable](https://img.shields.io/badge/lifecycle-stable-brightgreen.svg)](https://www.tidyverse.org/lifecycle/#stable) [![BioC status](http://www.bioconductor.org/shields/build/release/bioc/regutools.svg)](https://bioconductor.org/checkResults/release/bioc-LATEST/regutools) [![BioC dev status](http://www.bioconductor.org/shields/build/devel/bioc/regutools.svg)](https://bioconductor.org/checkResults/devel/bioc-LATEST/regutools) [![Codecov test coverage](https://codecov.io/gh/ComunidadBioInfo/regutools/branch/master/graph/badge.svg)](https://codecov.io/gh/ComunidadBioInfo/regutools?branch=master) [![R build status](https://github.com/ComunidadBioInfo/regutools/workflows/R-CMD-check-bioc/badge.svg)](https://github.com/ComunidadBioInfo/regutools/actions) [![Support site activity, last 6 months: tagged questions/avg. answers per question/avg. comments per question/accepted answers, or 0 if no tagged posts.](http://www.bioconductor.org/shields/posts/regutools.svg)](https://support.bioconductor.org/t/regutools/) [![GitHub issues](https://img.shields.io/github/issues/comunidadbioinfo/regutools)](https://github.com/comunidadbioinfo/regutools/issues) <!-- badges: end -->

The goal of `regutools` is to provide an R interface for extracting and processing data from [RegulonDB](http://regulondb.ccg.unam.mx/). This package was created as a collaboration by members of the [Community of Bioinformatics Software Developers](https://comunidadbioinfo.github.io/) (CDSB in Spanish).

For more details, please check the [documentation website](http://comunidadbioinfo.github.io/regutools) or the Bioconductor package landing page [here](https://bioconductor.org/packages/regutools).

## Installation

You can install the released version of `regutools` from [Bioconductor](http://bioconductor.org/) with:

``` r
if (!requireNamespace("BiocManager", quietly = TRUE)) {
      install.packages("BiocManager")
  }

BiocManager::install("regutools")

## Check that you have a valid Bioconductor installation
BiocManager::valid()
```

And the development version from [GitHub](https://github.com/) with:

``` r
BiocManager::install("ComunidadBioinfo/regutools")
```

## Example

This is a basic example which shows you how to use `regutools`. For more details, please check the vignette.

``` r
library("regutools")
## basic example code

## Connect to the RegulonDB database if necessary
if (!exists("regulondb_conn")) regulondb_conn <- connect_database()
#> snapshotDate(): 2021-08-03
#> adding rname 'https://www.dropbox.com/s/ufp6wqcv5211v1w/regulondb_v10.8_sqlite.db?dl=1'

## Build a regulondb object
e_coli_regulondb <-
    regulondb(
        database_conn = regulondb_conn,
        organism = "E.coli",
        database_version = "1",
        genome_version = "1"
    )

## Get the araC regulators
araC_regulation <-
    get_gene_regulators(
        e_coli_regulondb,
        genes = c("araC"),
        format = "multirow",
        output.type = "TF"
    )

## Summarize the araC regulation
get_regulatory_summary(e_coli_regulondb, araC_regulation)
#> regulondb_result with 3 rows and 7 columns
#>            TF Regulated_genes_per_TF          Percent   Activator   Repressor
#>   <character>            <character>      <character> <character> <character>
#> 1        AraC                      1 33.3333333333333           0           0
#> 2         CRP                      1 33.3333333333333           1           0
#> 3        XylR                      1 33.3333333333333           0           1
#>          Dual Regulated_genes
#>   <character>     <character>
#> 1           1            araC
#> 2           0            araC
#> 3           0            araC
```

## Documentation

For more information about `regutools` check the vignettes [through Bioconductor](http://bioconductor.org/packages/regutools) or at the [documentation website](http://comunidadbioinfo.github.io/regutools).

## Installation instructions

Get the latest stable `R` release from [CRAN](http://cran.r-project.org/). Then install `regutools` from [Bioconductor](http://bioconductor.org/) using the following code:

``` r
if (!requireNamespace("BiocManager", quietly = TRUE)) {
      install.packages("BiocManager")
  }

BiocManager::install("regutools")
```

## Citation

Below is the citation output from using `citation('regutools')` in R. Please run this yourself to check for any updates on how to cite **regutools**.

``` r
print(citation("regutools"), bibtex = TRUE)
#> 
#> Chávez J, Barberena-Jonas C, Sotelo-Fonseca JE, Alquicira-Hernandez J,
#> Salgado H, Collado-Torres L, Reyes A (2021). _regutools: an R package
#> for data extraction from RegulonDB_. doi: 10.18129/B9.bioc.regutools
#> (URL: https://doi.org/10.18129/B9.bioc.regutools),
#> https://github.com/comunidadbioinfo/regutools - R package version
#> 1.5.0, <URL: http://www.bioconductor.org/packages/regutools>.
#> 
#> A BibTeX entry for LaTeX users is
#> 
#>   @Manual{,
#>     title = {regutools: an R package for data extraction from RegulonDB},
#>     author = {Joselyn Chávez and Carmina Barberena-Jonas and Jesus Emiliano Sotelo-Fonseca and Jose Alquicira-Hernandez and Heladia Salgado and Leonardo Collado-Torres and Alejandro Reyes},
#>     year = {2021},
#>     url = {http://www.bioconductor.org/packages/regutools},
#>     note = {https://github.com/comunidadbioinfo/regutools - R package version 1.5.0},
#>     doi = {10.18129/B9.bioc.regutools},
#>   }
#> 
#> Chávez J, Barberena-Jonas C, Sotelo-Fonseca JE, Alquicira-Hernandez J,
#> Salgado H, Collado-Torres L, Reyes A (2020). "Programmatic access to
#> bacterial regulatory networks with regutools." _Bioinformatics_. doi:
#> 10.1093/bioinformatics/btaa575 (URL:
#> https://doi.org/10.1093/bioinformatics/btaa575), <URL:
#> https://academic.oup.com/bioinformatics/advance-article-abstract/doi/10.1093/bioinformatics/btaa575/5861528>.
#> 
#> A BibTeX entry for LaTeX users is
#> 
#>   @Article{,
#>     title = {Programmatic access to bacterial regulatory networks with regutools},
#>     author = {Joselyn Chávez and Carmina Barberena-Jonas and Jesus Emiliano Sotelo-Fonseca and Jose Alquicira-Hernandez and Heladia Salgado and Leonardo Collado-Torres and Alejandro Reyes},
#>     year = {2020},
#>     journal = {Bioinformatics},
#>     doi = {10.1093/bioinformatics/btaa575},
#>     url = {https://academic.oup.com/bioinformatics/advance-article-abstract/doi/10.1093/bioinformatics/btaa575/5861528},
#>   }
```

Please note that the `regutools` was only made possible thanks to many other R and bioinformatics software authors, which are cited either in the vignettes and/or the paper(s) describing this package.

## Code of Conduct

Please note that the derfinderPlot project is released with a [Contributor Code of Conduct](https://contributor-covenant.org/version/2/0/CODE_OF_CONDUCT.html). By contributing to this project, you agree to abide by its terms.

## Development tools

-   Continuous code testing is possible thanks to [GitHub actions](https://www.tidyverse.org/blog/2020/04/usethis-1-6-0/) through *[usethis](https://CRAN.R-project.org/package=usethis)*, *[remotes](https://CRAN.R-project.org/package=remotes)*, *[sysreqs](https://github.com/r-hub/sysreqs)* and *[rcmdcheck](https://CRAN.R-project.org/package=rcmdcheck)* customized to use [Bioconductor's docker containers](https://www.bioconductor.org/help/docker/) and *[BiocCheck](https://bioconductor.org/packages/3.14/BiocCheck)*.
-   Code coverage assessment is possible thanks to [codecov](https://codecov.io/gh) and *[covr](https://CRAN.R-project.org/package=covr)*.
-   The [documentation website](http://comunidadbioinfo.github.io/regutools) is automatically updated thanks to *[pkgdown](https://CRAN.R-project.org/package=pkgdown)*.
-   The code is styled automatically thanks to *[styler](https://CRAN.R-project.org/package=styler)*.
-   The documentation is formatted thanks to *[devtools](https://CRAN.R-project.org/package=devtools)* and *[roxygen2](https://CRAN.R-project.org/package=roxygen2)*.

For more details, check the `dev` directory.

This package was developed using *[biocthis](https://bioconductor.org/packages/3.14/biocthis)*.

# RegulonDB

<a href="http://regulondb.ccg.unam.mx/"><img src="http://regulondb.ccg.unam.mx/img/logo.jpg"></a>

# A CDSB community project

<a href="https://comunidadbioinfo.github.io/"><img src="https://comunidadbioinfo.github.io/img/Logo_texto-768x107.png"></a>

#' @title Extract data from RegulonDB
#' @description This function retrieves data from RegulonDB. Attributes from
#' datasets can be selected and filtered.
#' @param regulondb A [regulondb()] object.
#' @param dataset Dataset of interest. Use the function list_datasets for an
#' overview of valid datasets.
#' @param attributes Vector of attributes to be retrieved.
#' @param filters List of filters to be used. The names should correspond to
#' the attribute and the values correspond to the condition for selection.
#' @param and Logical argument. If FALSE, filters will be considered under the
#' "OR" operator
#' @param partialmatch name of the condition(s) with a string pattern for full
#' or partial match in the query
#' @param interval the filters whose values will be considered as interval
#' @param output_format A string specifying the output format. Possible options
#' are "regulondb_result", "GRanges", "DNAStringSet" or "BStringSet".
#' @author Carmina Barberena Jonas, Jesús Emiliano Sotelo Fonseca,
#' José Alquicira Hernández, Joselyn Chávez
#' @return By default, a regulon_results object. If specified in the parameter
#' output_format, it can also return either a GRanges object or a Biostrings
#' object.
#' @importFrom IRanges IRanges
#' @importFrom GenomicRanges strand mcols "strand<-" "mcols<-"
#' @examples
#' ## Connect to the RegulonDB database if necessary
#' if (!exists("regulondb_conn")) regulondb_conn <- connect_database()
#'
#' ## Build the regulon db object
#' e_coli_regulondb <-
#'     regulondb(
#'         database_conn = regulondb_conn,
#'         organism = "E.coli",
#'         database_version = "1",
#'         genome_version = "1"
#'     )
#'
#' ## Obtain all the information from the "GENE" dataset
#' get_dataset(e_coli_regulondb, dataset = "GENE")
#'
#' ## Get the attributes posright and name from the "GENE" dataset
#' get_dataset(e_coli_regulondb,
#'     dataset = "GENE",
#'     attributes = c("posright", "name")
#' )
#'
#' ## From "GENE" dataset, get the gene name, strand, posright, product name
#' ## and id of all genes regulated with name like "ara", strand as "forward"
#' ## with a position right between 2000 and 40000
#' get_dataset(
#'     e_coli_regulondb,
#'     dataset = "GENE",
#'     attributes = c("name", "strand", "posright", "product_name", "id"),
#'     filters = list(
#'         name = c("ara"),
#'         strand = c("forward"),
#'         posright = c("2000", "40000")
#'     ),
#'     and = TRUE,
#'     partialmatch = "name",
#'     interval = "posright"
#' )
#' @export
#' @importFrom S4Vectors DataFrame
#' @importFrom Biostrings DNAStringSet BStringSet
get_dataset <-
    function(regulondb,
    dataset = NULL,
    attributes = NULL,
    filters = NULL,
    and = TRUE,
    interval = NULL,
    partialmatch = NULL,
    output_format = "regulondb_result") {
        # Check if format specification is valid
        if (!output_format %in% c(
            "regulondb_result",
            "GRanges",
            "DNAStringSet",
            "BStringSet"
        )) {
            stop(
                paste(
                    "Output format must be one of the following:",
                    "regulondb_result, GRanges, DNAStringSet or BStringSet"
                ),
                call. = FALSE
            )
        }

        # Validate if attributes is a vector
        if (!is.null(attributes) & (!is.vector(attributes))) {
            stop("Parameter 'attributes' must be a vector", call. = FALSE)
        }

        # Validate dataset
        if (is.null(dataset)) {
            stop("Non dataset provided", call. = FALSE)
        }
        if (!all(dataset %in% list_datasets(regulondb))) {
            stop("Invalid dataset. See valid datasets in list_datasets()",
                call. = FALSE
            )
        }

        # Validate attributes
        if (!all(attributes %in% list_attributes(regulondb, dataset))) {
            non.existing.attrs.index <-
                attributes %in% list_attributes(regulondb, dataset)
            non.existing.attrs <-
                attributes[!non.existing.attrs.index]
            stop(
                "Attribute(s) ",
                paste0('"', paste(non.existing.attrs, collapse = ", "), '"'),
                " do not exist. See valid attributes in list_attributes()",
                call. = FALSE
            )
        }

        # Validate partialmatch

        if (!all(partialmatch %in% list_attributes(regulondb, dataset))) {
            non.existing.attrs.index <-
                partialmatch %in% list_attributes(regulondb, dataset)
            non.existing.attrs <-
                partialmatch[!non.existing.attrs.index]
            stop("Partialmatch ",
                paste0('"', paste(non.existing.attrs, collapse = ", "), '"'),
                " do not exist.",
                call. = FALSE
            )
        }

        if (!all(partialmatch %in% names(filters))) {
            non.existing.attrs.index <- partialmatch %in% names(filters)
            non.existing.attrs <-
                partialmatch[!non.existing.attrs.index]
            stop("Partialmatch ",
                paste0('"', paste(non.existing.attrs, collapse = ", "), '"'),
                " not defined in 'filters' ",
                call. = FALSE
            )
        }

        # Sets logical operator
        if (and) {
            operator <- "AND"
        } else {
            operator <- "OR"
        }

        if (is.null(filters) & is.null(attributes)) {
            query <- paste0("SELECT * FROM ", dataset, ";")
        } else if (is.null(attributes) & !is.null(filters)) {
            cond <-
                build_condition(
                    regulondb,
                    dataset,
                    filters,
                    operator,
                    interval,
                    partialmatch
                )
            query <-
                paste0("SELECT * FROM ", dataset, " WHERE ", cond, ";")
        } else if (!is.null(attributes) & is.null(filters)) {
            query <-
                paste0(
                    "SELECT ",
                    paste(attributes, collapse = " , "),
                    " FROM ",
                    dataset,
                    ";"
                )
        } else {
            cond <-
                build_condition(
                    regulondb,
                    dataset,
                    filters,
                    operator,
                    interval,
                    partialmatch
                )
            query <-
                paste(
                    "SELECT ",
                    paste(attributes, collapse = " , "),
                    "FROM ",
                    dataset,
                    " WHERE ",
                    cond,
                    ";"
                ) # Construct query
        }
        result <- dbGetQuery(regulondb, query)

        # Check if results exist
        if (!nrow(result)) {
            warning("Your query returned no results.")
        }

        result <- new(
            "regulondb_result",
            DataFrame(result),
            organism = regulondb@organism,
            genome_version = regulondb@genome_version,
            database_version = regulondb@database_version,
            dataset = dataset
        )

        if (output_format == "GRanges") {
            result <- convert_to_granges(result)
        } else if (output_format == "DNAStringSet") {
            result <- convert_to_biostrings(result, seq_type = "DNA")
        } else if (output_format == "BStringSet") {
            result <- convert_to_biostrings(result, seq_type = "product")
        }

        result
    }

#' @title Function to convert output of regulondb queries to GenomicRanges objects
#' @description This function converts, when possible, a regulon_result object into a GRanges object.
#' @param regulondb_result A regulon_result object.
#' @author Alejandro Reyes
#' @importFrom GenomicRanges GRanges
#' @importFrom S4Vectors metadata "metadata<-"
#' @return A [GRanges][GenomicRanges::GRanges-class] object.
#' @export
#' @examples
#' ## Connect to the RegulonDB database if necessary
#' if (!exists("regulondb_conn")) regulondb_conn <- connect_database()
#'
#' ## Build the regulon db object
#' e_coli_regulondb <-
#'     regulondb(
#'         database_conn = regulondb_conn,
#'         organism = "E.coli",
#'         database_version = "1",
#'         genome_version = "1"
#'     )
#'
#' ## Obtain all the information from the "GENE" dataset
#' convert_to_granges(get_dataset(e_coli_regulondb, dataset = "GENE"))
convert_to_granges <- function(regulondb_result) {
    if (!is(regulondb_result, "regulondb_result")) {
          stop("The input is not a 'regulondb_result' object.")
      }
    dataset <- regulondb_result@dataset
    if (dataset %in% c("GENE", "DNA_OBJECTS")) {
        posLeft <- "posleft"
        posRight <- "posright"
    } else if (dataset == "OPERON") {
        posLeft <- "regulationposleft"
        posRight <- "regulationposright"
    } else {
        stop(
            sprintf(
                paste(
                    "Can not coerse 'regulondb_result' from dataset %s",
                    "into a GRanges object\n"
                ),
                dataset
            )
        )
    }
    if (all(c(posLeft, posRight) %in% names(regulondb_result))) {
        ### coding of regulondb for missing coordinates ###
        nopos <-
            regulondb_result[[posLeft]] == 9999999999 &
                regulondb_result[[posRight]] == 0
        keep <-
            !(is.na(regulondb_result[[posLeft]]) |
                is.na(regulondb_result[[posRight]]))
        keep <- keep & !nopos
        grdata <- GRanges(
            regulondb_result@organism,
            IRanges(
                start = regulondb_result[[posLeft]][keep],
                end = regulondb_result[[posRight]][keep]
            )
        )
        if ("strand" %in% names(regulondb_result)) {
            stnd <-
                ifelse(regulondb_result$strand[which(keep)] == "forward",
                    "+", "-"
                )
            stnd[which(is.na(stnd))] <- "*"
            strand(grdata) <- stnd
        }
        mcols(grdata) <-
            DataFrame(regulondb_result[keep, !colnames(regulondb_result) %in%
                c(posLeft, posRight, "strand"), drop = FALSE])
        if (sum(!keep) > 0) {
              warning(sprintf(
                  "Dropped %s entries where genomic coordinates were NAs",
                  sum(!keep)
              ))
          }
        grdata
    } else {
        stop(
            sprintf(
                paste(
                    "Not enough information to convert into a GRanges",
                    "object. Please make sure that the input the following",
                    "columns: \n\t%s"
                ),
                paste(c(posLeft, posRight), collapse = "\n\t")
            ),
            call. = FALSE
        )
    }
    metadata(grdata) <- c(
        metadata(grdata),
        list(
            organism = regulondb_result@organism,
            genome_version = regulondb_result@genome_version,
            database_version = regulondb_result@database_version,
            dataset = regulondb_result@dataset
        )
    )
    grdata
}

#' @title Function to convert output of regulondb queries to Biostrings objects
#' @description This function converts, when possible, a regulon_result object into a Biostrings object.
#' @param regulondb_result A regulon_result object.
#' @param seq_type A character string with either DNA or protein, specyfing what
#' @author Alejandro Reyes
#' @importFrom Biostrings DNAStringSet AAStringSet
#' @return A [XStringSet][Biostrings::XStringSet-class] object.
#' @export
#' @examples
#' ## Connect to the RegulonDB database if necessary
#' if (!exists("regulondb_conn")) regulondb_conn <- connect_database()
#'
#' ## Build the regulon db object
#' e_coli_regulondb <-
#'     regulondb(
#'         database_conn = regulondb_conn,
#'         organism = "E.coli",
#'         database_version = "1",
#'         genome_version = "1"
#'     )
#'
#' ## Obtain all the information from the "GENE" dataset
#' convert_to_biostrings(get_dataset(e_coli_regulondb, dataset = "GENE"))
convert_to_biostrings <-
    function(regulondb_result, seq_type = "DNA") {
        if (!is(regulondb_result, "regulondb_result")) {
              stop("The input is not a 'regulondb_result' object.")
          }
        if (!seq_type %in% c("DNA", "product")) {
              stop("'seq_type' must be either 'DNA' or 'product'")
          }
        dataset <- regulondb_result@dataset
        if (dataset == "GENE") {
            if (seq_type == "DNA") {
                func <- Biostrings::DNAStringSet
                col_name <- "dna_sequence"
            } else {
                func <- Biostrings::BStringSet
                col_name <- "product_sequence"
            }
        } else if (dataset == "PROMOTER") {
            func <- Biostrings::DNAStringSet
            col_name <- "promoter_sequence"
        } else {
            stop(
                sprintf(
                    paste(
                        "Can not coerse 'regulondb_result' from dataset %s",
                        "into a Biostrings object\n"
                    ),
                    dataset
                )
            )
        }
        if (!col_name %in% colnames(regulondb_result)) {
            stop(
                sprintf(
                    paste(
                        "Not enough information to convert to a Biostrings",
                        "object.\nPlease add the following column to the",
                        "regulondb_result object: \n\t%s\n"
                    ),
                    col_name
                )
            )
        }
        seq_character <-
            gsub("\\*$", "", regulondb_result[[col_name]])
        keep <- !is.na(seq_character)
        rs <- func(seq_character[which(keep)])
        mcols(rs) <-
            regulondb_result[which(keep), !colnames(regulondb_result) %in%
                col_name, drop = FALSE]
        if (sum(!keep)) {
            warning(sprintf(
                "Dropped %s entries where sequence data were NAs",
                sum(!keep)
            ))
        }
        metadata(rs) <- c(
            metadata(rs),
            list(
                organism = regulondb_result@organism,
                genome_version = regulondb_result@genome_version,
                database_version = regulondb_result@database_version,
                dataset = regulondb_result@dataset
            )
        )
        rs
    }

dataframe_to_dbresult <- function(df, regulondb, dataset) {
    new(
        "regulondb_result",
        DataFrame(df),
        organism = regulondb@organism,
        genome_version = regulondb@genome_version,
        database_version = regulondb@database_version,
        dataset = dataset
    )
}

context("get_dataset")
test_that("Function get dataset works as expected", {
    ## Connect to the RegulonDB database if necessary
    if (!exists("regulondb_conn")) {
          regulondb_conn <- connect_database()
      }

    ## Build a regulondb object
    regdb <-
        regulondb(
            database_conn = regulondb_conn,
            organism = "prueba",
            genome_version = "prueba",
            database_version = "prueba"
        )
    query <- get_dataset(
        regdb,
        dataset = "GENE",
        attributes = c("posleft", "posright", "name", "strand"),
        filters = list(name = c("araC", "crp", "lacI"))
    )
    expect_s4_class(query, "regulondb_result")
    expect_error(
        get_dataset(
            regdb,
            dataset = "GENE",
            attributes = c("posleft", "posright", "name", "strand"),
            filters = list(name = c("araC", "crp", "lacI")),
            output_format = "ss"
        )
    )
    expect_s4_class(
        suppressWarnings(
            get_dataset(
                regdb,
                dataset = "GENE",
                attributes = c("posleft", "posright", "name", "strand"),
                and = FALSE,
                output_format = "GRanges"
            )
        ),
        "GRanges"
    )
    expect_s4_class(
        get_dataset(
            regdb,
            dataset = "OPERON",
            filters = list(name = c("araC")),
            output_format = "GRanges"
        ),
        "GRanges"
    )


    expect_s4_class(
        suppressWarnings(
            get_dataset(regdb,
                dataset = "OPERON",
                output_format = "GRanges"
            )
        ),
        "GRanges"
    )


    expect_s4_class(
        get_dataset(
            regdb,
            dataset = "GENE",
            filters = list(name = c("araC", "crp", "lacI")),
            attributes = c("posleft", "posright", "name", "strand", "dna_sequence"),
            output_format = "DNAStringSet"
        ),
        "DNAStringSet"
    )

    expect_s4_class(
        get_dataset(
            regdb,
            dataset = "GENE",
            filters = list(name = c("araC", "crp", "lacI")),
            attributes = c("posleft", "posright", "name", "strand", "dna_sequence"),
            output_format = "DNAStringSet"
        ),
        "DNAStringSet"
    )
    expect_warning(
        get_dataset(
            regdb,
            dataset = "PROMOTER",
            attributes = c(
                "name",
                "strand",
                "promoter_sequence"
            ),
            output_format = "BStringSet"
        ),
        "Dropped 92 entries where sequence data were NAs"
    )


    expect_error(
        suppressWarnings(
            get_dataset(
                regdb,
                dataset = "PROMOTER",
                filters = list(name = c("araC", "crp", "lacI")),
                attributes = c("name", "strand"),
                output_format = "DNAStringSet"
            )
        ),
        "Not enough information to convert to a Biostrings object.\nPlease add the following column to the regulondb_result object: \n\tpromoter_sequence\n"
    )

    expect_error(
        get_dataset(
            regdb,
            dataset = "GENE",
            filters = list(name = c("araC", "crp", "lacI")),
            attributes = c(
                "posleft",
                "posright",
                "name",
                "strand"
            ),
            output_format = "BStringSet"
        )
    )


    expect_error(get_dataset(
        regdb,
        dataset = "OPERON",
        attributes = c("name"),
        output_format = "GRanges"
    ))

    expect_warning(get_dataset(
        regdb,
        dataset = "GENE",
        attributes = c("posleft", "posright", "name", "strand"),
        filters = list(name = c("thisisnotagene"))
    ))
    # Errors
    expect_error(
        get_dataset(
            regdb,
            dataset = "GENE",
            attributes = query,
            filters = list(name = c("thisisnotagene"))
        ),
        "Parameter 'attributes' must be a vector"
    )
    expect_error(
        get_dataset(
            regdb,
            attributes = c("posleft", "posright", "name", "strand"),
            filters = list(name = c("thisisnotagene"))
        ),
        "Non dataset provided"
    )
    expect_error(
        get_dataset(
            regdb,
            dataset = "GENe",
            attributes = c("posleft", "posright", "name", "strand"),
            filters = list(name = c("thisisnotagene"))
        ),
        "Invalid dataset. See valid datasets in list_datasets()"
    )
    expect_error(get_dataset(
        regdb,
        dataset = "GENE",
        attributes = c("posleft", "posright", "name", "stran"),
        filters = list(name = c("thisisnotagene"))
    ))
    expect_error(
        get_dataset(
            regdb,
            dataset = "GENE",
            attributes = c("posleft", "posright", "name", "strand"),
            filters = list(name = c("araC")),
            partialmatch = "names"
        ),
        "Partialmatch \"names\" do not exist"
    )

    expect_error(
        get_dataset(
            regdb,
            dataset = "GENE",
            attributes = c("posleft", "posright", "name", "strand"),
            filters = list(name = c("araC")),
            partialmatch = "posleft"
        ),
        "Partialmatch \"posleft\" not defined in 'filters'"
    )
})

context("GRanges_convert")
test_that("Results from regulondb queries can be converted to GRanges", {
    ## Connect to the RegulonDB database if necessary
    if (!exists("regulondb_conn")) {
          regulondb_conn <- connect_database()
      }

    ## Build a regulondb object
    regdb <-
        regulondb(
            database_conn = regulondb_conn,
            organism = "prueba",
            genome_version = "prueba",
            database_version = "prueba"
        )
    query <- get_dataset(
        regdb,
        dataset = "GENE",
        attributes = c("posleft", "posright", "name", "strand"),
        filters = list(name = c("araC", "crp", "lacI"))
    )
    expect_s4_class(convert_to_granges(query), "GRanges")
    expect_error(convert_to_granges(query[, c("posleft", "name")]))
    expect_s4_class(convert_to_granges(query[, c("posleft", "posright")]), "GRanges")
    query <- get_dataset(
        regulondb = regdb,
        dataset = "DNA_OBJECTS"
    )
    hasNAs <- is.na(query$posleft) | is.na(query$posright)
    expect_s4_class(convert_to_granges(query[!hasNAs, ]), "GRanges")
    if (sum(hasNAs) > 0) {
        expect_warning(
            convert_to_granges(query),
            sprintf(
                "Dropped %s entries where genomic coordinates were NAs",
                sum(hasNAs)
            )
        )
    }
    expect_error(convert_to_granges(as.data.frame(query)))
    query <- get_dataset(regulondb = regdb, dataset = "OPERON")
    query$posright
    rs <- suppressWarnings(convert_to_granges(query))
    expect_s4_class(rs, "GRanges")
    metaSlots <-
        setdiff(slotNames(query), slotNames(as(query, "DataFrame")))
    expect_true(all(metaSlots %in% names(metadata(rs))))
    ##  query <- get_dataset( regulondb=regdb, dataset="RI" )
    ##  expect_s4_class( convert_to_granges( query ), "GRanges" )
    query <- get_dataset(
        regulondb = regdb,
        dataset = "TF",
        attributes = "total_regulated_tf",
        filters = list(name = c("Fis", "Rob", "TyrR"))
    )
    expect_error(convert_to_granges(query))
})

test_that("Results from regulondb queries can be converted to Biostrings", {
    ## Connect to the RegulonDB database if necessary
    if (!exists("regulondb_conn")) {
          regulondb_conn <- connect_database()
      }

    ## Build a regulondb object
    regdb <-
        regulondb(
            database_conn = regulondb_conn,
            organism = "prueba",
            genome_version = "prueba",
            database_version = "prueba"
        )
    query <- get_dataset(
        regdb,
        dataset = "GENE",
        attributes = c(
            "posleft",
            "posright",
            "name",
            "strand",
            "dna_sequence",
            "product_sequence"
        ),
        filters = list(name = c("araC", "crp", "lacI"))
    )
    expect_s4_class(convert_to_biostrings(query), "DNAStringSet")
    expect_s4_class(
        convert_to_biostrings(query, seq_type = "product"),
        "BStringSet"
    )
    expect_error(convert_to_biostrings(query, seq_type = "other"))
    query2 <- get_dataset(regdb, dataset = "PROMOTER")
    isNA <- is.na(query2[["promoter_sequence"]])
    rs <- convert_to_biostrings(query2[!isNA, ])
    if (sum(isNA) > 0) {
        expect_warning(
            convert_to_biostrings(query2),
            sprintf(
                "Dropped %s entries where sequence data were NAs",
                sum(isNA)
            )
        )
    }
    expect_s4_class(rs, "DNAStringSet")
    expect_equal(
        length(suppressWarnings(convert_to_biostrings(query2))),
        sum(!is.na(query2$promoter_sequence))
    )
    query3 <-
        get_dataset(regdb,
            dataset = "NETWORK",
            filters = list(regulated_name = "acrD")
        )
    expect_error(convert_to_biostrings(query3))
    expect_error(convert_to_biostrings(data.frame()))
    metaSlots <-
        setdiff(slotNames(query2), slotNames(as(query2, "DataFrame")))
    expect_true(all(metaSlots %in% names(metadata(rs))))
})

## For this script
dir.create(here::here('inst', 'scripts'), recursive = TRUE)

## Download the DB file

dir.create(here::here('data-raw'))
usethis::use_data_raw()
unlink(here::here('data-raw', 'DATASET.R'))
## This function was dropped during the development of regutools
# regutools::download_database(here::here('data-raw'), overwrite = FALSE, ah = NULL)

## Rename if necessary
# file.rename(file.path(here::here('data-raw', 'regulon_sqlite3.db')),
#     file.path(here::here(
#         'data-raw', 'regulon_sqlite3_v10.6.2_DM.db'
#     )))

#' Retrieve genomic elements from regulonDB
#'
#' @param regulondb A [regulondb()] object.
#' @param genome A valid UCSC genome name.
#' @param grange A [GenomicRanges::GRanges-class()] object indicating position
#'  left and right.
#' @param elements A character vector specifying which annotation elements to
#' plot. It can be any from: `"-10 promoter box"`, `"-35 promoter box"`,
#' `"gene"`, `"promoter"`, `"Regulatory Interaction"`, `"sRNA interaction"`,
#' or `"terminator"`.
#' @author Joselyn Chavez
#' @return [GenomicRanges::GRanges-class()] object with the elements found.
#' @importFrom Gviz GeneRegionTrack plotTracks GenomeAxisTrack AnnotationTrack
#' @importFrom GenomicRanges GRanges
#' @importFrom IRanges IRanges
#' @examples
#' ## Connect to the RegulonDB database if necessary
#' if (!exists("regulondb_conn")) {
#'       regulondb_conn <- connect_database()
#'   }
#'
#' ## Build the regulondb object
#' e_coli_regulondb <-
#'     regulondb(
#'         database_conn = regulondb_conn,
#'         organism = "chr",
#'         database_version = "1",
#'         genome_version = "1"
#'     )
#'
#' ## Get all genes from E. coli
#' get_dna_objects(e_coli_regulondb)
#'
#' ## Get genes providing Genomic Ranges
#' grange <- GenomicRanges::GRanges(
#'     "chr",
#'     IRanges::IRanges(5000, 10000)
#' )
#' get_dna_objects(e_coli_regulondb, grange)
#'
#' ## Get aditional elements within genomic positions
#' get_dna_objects(e_coli_regulondb,
#'     grange,
#'     elements = c("gene", "promoter")
#' )
#' @export
get_dna_objects <-
    function(regulondb,
    genome = "eschColi_K12",
    grange = GRanges("chr", IRanges(1, 5000)),
    elements = "gene") {
        valid_elements <- c(
            "-10 promoter box",
            "-35 promoter box",
            "gene",
            "promoter",
            "Regulatory Interaction",
            "sRNA interaction",
            "terminator"
        )
        # Validate elements
        if (!all(elements %in% valid_elements)) {
            non.valid.elements.index <- elements %in% valid_elements
            non.valid.elements <- elements[!non.valid.elements.index]
            stop(
                "Element(s) ",
                paste0('"', paste(non.valid.elements, collapse = ", "), '"'),
                paste(
                    " are not valid. Please provide any or all of these",
                    "valid elements: "
                ),
                paste0('"', paste(valid_elements, collapse = ", "), '"'),
                call. = FALSE
            )
        }
        # search for dna_objects ("-10 promoter box", -35 promoter box", "gene",
        # "promoter", "Regulatory Interaction","sRNA interaction","terminator")
        dna_objects <- regutools::get_dataset(
            regulondb,
            dataset = "DNA_OBJECTS",
            filters = list(
                posright = c(
                    grange@ranges@start,
                    grange@ranges@start +
                        grange@ranges@width
                ),
                type = elements
            ),
            interval = "posright",
            output_format = "GRanges"
        )

        # Return GRanges result
        dna_objects
    }

context("get_dna_objects")
test_that("output is a GRanges object", {
    ## Connect to the RegulonDB database if necessary
    if (!exists("regulondb_conn")) {
          regulondb_conn <- connect_database()
      }

    ## Build a regulondb object
    regdb <-
        regulondb(
            database_conn = regulondb_conn,
            organism = "chr",
            genome_version = "prueba",
            database_version = "prueba"
        )
    reg_result <- get_dna_objects(regdb)

    expect_equivalent(class(reg_result), "GRanges")
})

test_that("non-valid genomic elements causes error", {
    expect_error(get_dna_objects(
        regdb,
        elements = c("gene", "promotr")
    ))
})


test_that("non-valid granges causes error", {
    expect_error(get_dna_objects(
        regdb,
        grange = GRanges("chr", IRanges(5000, "a"))
    ))
})

#' Connect to the regulondb database
#' @description This function downloads the RegulonDB SQLite database file
#' prior to making a connection to it. It will cache the database file such
#' that subsequent calls will run faster. This function requires an active
#' internet connection.
#' @param ah An `AnnotationHub` object
#' [AnnotationHub-class][AnnotationHub::AnnotationHub-class]. Can be `NULL`
#' if you want to force to use the backup download mechanism.
#' @param bfc A `BiocFileCache` object
#' [BiocFileCache-class][BiocFileCache::BiocFileCache-class]. Used when
#' `ah` is not available.
#' @return An [SQLiteConnection-class][RSQLite::SQLiteConnection-class]
#' connection to the RegulonDB database.
#' @export
#' @importFrom utils download.file
#' @import AnnotationHub
#' @importFrom AnnotationDbi dbFileConnect
#' @importFrom BiocFileCache BiocFileCache bfcrpath
#'
#' @examples
#'
#' ## Connect to the RegulonDB database if necessary
#' if (!exists("regulondb_conn")) regulondb_conn <- connect_database()
#'
#' ## Connect to the database without using AnnotationHub
#' regulondb_conn_noAH <- connect_database(ah = NULL)
connect_database <-
    function(
    ah = AnnotationHub::AnnotationHub(),
    bfc = BiocFileCache::BiocFileCache()) {
        if (!is.null(ah)) {
            ## Check input
            stopifnot(methods::is(ah, "AnnotationHub"))

            ## Query AH
            q <-
                AnnotationHub::query(
                    ah,
                    pattern = c(
                        paste(
                            "RegulonDB SQLite database version v10.8",
                            "for the regutools Bioconductor package"
                        ),
                        "regutools;RegulonDB;v10.8"
                    )
                )
            if (length(q) == 1) {
                ## Return the connection
                return(q[[1]])
            }
        }


        ## Otherwise, use the Dropbox version and cache it with BiocFileCache
        url <-
            paste0(
                "https://www.dropbox.com/s/ufp6wqcv5211v1w/",
                "regulondb_v10.8_sqlite.db?dl=1"
            )
        destfile <- BiocFileCache::bfcrpath(bfc, url)
        AnnotationDbi::dbFileConnect(destfile)
    }

context("Binding sites")
test_that("Function to get transcription factor binding sites works as expected", {
    ## Connect to the RegulonDB database if necessary
    if (!exists("regulondb_conn")) {
          regulondb_conn <- connect_database()
      }

    ## Build a regulondb object
    regdb <-
        regulondb(
            database_conn = regulondb_conn,
            organism = "prueba",
            genome_version = "prueba",
            database_version = "prueba"
        )
    rs <-
        get_binding_sites(regdb, transcription_factor = "AraC")
    expect_s4_class(rs, "GRanges")
    rs <- get_binding_sites(regdb,
        transcription_factor = "AraC",
        output_format = "Biostrings"
    )
    expect_s4_class(rs, "DNAStringSet")
    expect_error(get_binding_sites(
        regdb,
        transcription_factor = "AraC",
        output_format = "other"
    ))
    expect_null(suppressWarnings(
        get_binding_sites(regdb, transcription_factor = "thisisnotagene")
    ))
})

context("build_condition")
test_that("Test that the logical conditions its made as expected", {
    ## Connect to the RegulonDB database if necessary
    if (!exists("regulondb_conn")) {
          regulondb_conn <- connect_database()
      }

    ## Build a regulondb object
    regdb <-
        regulondb(
            database_conn = regulondb_conn,
            organism = "prueba",
            genome_version = "prueba",
            database_version = "prueba"
        )
    condi_interval <- build_condition(
        regdb,
        dataset = "GENE",
        filters = list(posright = c("2000", "40000")),
        operator = NULL,
        interval = "posright",
        partialmatch = NULL
    )
    expect_match(condi_interval, ">=")
    expect_match(condi_interval, "<=")
    # More that one interval
    condi_2_filters_as_interval <-
        build_condition(
            regdb,
            dataset = "GENE",
            filters = list(
                posright = c("2000", "40000"),
                posleft = c("2000", "40000")
            ),
            operator = NULL,
            interval = c("posright", "posleft"),
            partialmatch = NULL
        )
    expect_match(condi_2_filters_as_interval, ">=")
    expect_match(condi_2_filters_as_interval, "<=")
    # Type character
    expect_type(condi_interval, "character")
    # Length 1
    expect_length(condi_interval, 1)
    # Having more that 2 values for intervales
    expect_warning(
        build_condition(
            regdb,
            dataset = "GENE",
            filters = list(
                posright = c("2000", "40000", "50000"),
                name = c("ara")
            ),
            operator = NULL,
            interval = "posright",
            partialmatch = NULL
        ),
        "Only the first two values of interval will be considered."
    )

    # Having only one value
    expect_error(
        build_condition(
            regdb,
            dataset = "GENE",
            filters = list(posright = c("2000")),
            operator = NULL,
            interval = "posright",
            partialmatch = NULL
        ),
        "Two values in the interval filter are required. "
    )

    # Diferent operators
    condi_operar_and <- build_condition(
        regdb,
        dataset = "GENE",
        filters = list(
            name = c("ara"),
            strand = c("forward")
        ),
        operator = "AND",
        interval = NULL,
        partialmatch = NULL
    )
    expect_match(condi_operar_and, "AND")

    condi_no_interval <- build_condition(
        regdb,
        dataset = "GENE",
        filters = list(posright = c("2000", "40000")),
        operator = NULL,
        interval = "posright",
        partialmatch = NULL
    )

    condi_operar_or <- build_condition(
        regdb,
        dataset = "GENE",
        filters = list(
            name = c("ara"),
            strand = c("forward")
        ),
        operator = "OR",
        interval = NULL,
        partialmatch = NULL
    )
    expect_match(condi_operar_or, "OR")

    # errors

    expect_error(
        build_condition(
            regdb,
            dataset = "GENE",
            filters = list(posrig = c("2000", "40000")),
            operator = NULL,
            interval = c("name"),
            partialmatch = NULL
        )
    )

    expect_error(
        build_condition(
            regdb,
            dataset = "GENE",
            filters = list(posright = c("2000", "40000")),
            operator = NULL,
            interval = c("posrigh", "name"),
            partialmatch = NULL
        )
    )
    expect_error(
        build_condition(
            regdb,
            dataset = "GENE",
            filters = "posrigh",
            operator = NULL,
            interval = "posrigh",
            partialmatch = NULL
        ),
        "The argument filters is not a list"
    )
})

context("list_datasets")
test_that("function list_dataset works as expected", {
    ## Connect to the RegulonDB database if necessary
    if (!exists("regulondb_conn")) {
          regulondb_conn <- connect_database()
      }

    ## Build a regulondb object
    regdb <-
        regulondb(
            database_conn = regulondb_conn,
            organism = "prueba",
            genome_version = "prueba",
            database_version = "prueba"
        )

    # Returns a character vector
    expect_type(list_datasets(regdb), "character")

    # Test that function fails if not database is provided
    expect_error(list_datasets(), "")
})

context("build_condition")

test_that("existing_intervals returns an expected value", {
    ## Connect to the RegulonDB database if necessary
    if (!exists("regulondb_conn")) {
          regulondb_conn <- connect_database()
      }

    ## Build a regulondb object
    regdb <-
        regulondb(
            database_conn = regulondb_conn,
            organism = "prueba",
            genome_version = "prueba",
            database_version = "prueba"
        )

    existing_intervals <- build_condition(
        regdb,
        dataset = "GENE",
        filters = list(
            posright = c("2000", "40000"),
            posleft = c("2000", "40000")
        ),
        operator = NULL,
        interval = c("posright", "posleft"),
        partialmatch = NULL
    )
    expect_match(existing_intervals, ">=")
    # Having partial match
    existing_intervals_and_pm <-
        build_condition(
            regdb,
            dataset = "GENE",
            filters = list(
                name = c("ara"),
                strand = c("forward"),
                posright = c("2000", "40000")
            ),
            operator = "AND",
            interval = "posright",
            partialmatch = "name"
        )
    # Type character
    expect_type(existing_intervals_and_pm, "character")
    # Length 1
    expect_length(existing_intervals_and_pm, 1)


    # Having more that 2 values for intervales
    expect_warning(
        build_condition(
            regdb,
            dataset = "GENE",
            filters = list(
                posright = c("2000", "40000", "50000"),
                name = c("ara")
            ),
            operator = NULL,
            interval = "posright",
            partialmatch = NULL
        ),
        "Only the first two values of interval will be considered."
    )

    # Having only one value
    expect_error(
        build_condition(
            regdb,
            dataset = "GENE",
            filters = list(posright = c("2000")),
            operator = NULL,
            interval = "posright",
            partialmatch = NULL
        ),
        "Two values in the interval filter are required. "
    )
})

context("build_condition")

test_that("existing_partial_match returns an expected value", {
    ## Connect to the RegulonDB database if necessary
    if (!exists("regulondb_conn")) {
          regulondb_conn <- connect_database()
      }

    ## Build a regulondb object
    regdb <-
        regulondb(
            database_conn = regulondb_conn,
            organism = "prueba",
            genome_version = "prueba",
            database_version = "prueba"
        )

    # Type character
    expect_type(
        existing_partial_match(
            filters = list(name = c("rec")),
            partialmatch = "name",
            operator = NULL
        ),
        "character"
    )
    # Length 1
    expect_length(
        existing_partial_match(
            filters = list(name = c("ara")),
            partialmatch = "name",
            operator = NULL
        ),
        1
    )
})

context("list_attributes")
test_that("list_attributes works as expected ", {
    ## Connect to the RegulonDB database if necessary
    if (!exists("regulondb_conn")) {
          regulondb_conn <- connect_database()
      }

    ## Build a regulondb object
    regdb <-
        regulondb(
            database_conn = regulondb_conn,
            organism = "prueba",
            genome_version = "prueba",
            database_version = "prueba"
        )

    # Returns a character vector
    expect_type(
        list_attributes(regdb, dataset = "DNA_OBJECTS"),
        "character"
    )

    # Test that function fails if not enough arguments are given
    expect_error(list_attributes(), "")
    expect_error(list_attributes(regdb), "")
})

context("build_condition")

test_that("existing_partial_match returns an expected value", {
    ## Connect to the RegulonDB database if necessary
    if (!exists("regulondb_conn")) {
          regulondb_conn <- connect_database()
      }

    ## Build a regulondb object
    regdb <-
        regulondb(
            database_conn = regulondb_conn,
            organism = "prueba",
            genome_version = "prueba",
            database_version = "prueba"
        )

    # No intervals no partial match
    no_intervals <- build_condition(
        regdb,
        dataset = "GENE",
        filters = list(
            name = c("ara"),
            strand = c("forward")
        ),
        operator = "AND",
        interval = NULL,
        partialmatch = NULL
    )
    # Type character
    expect_type(no_intervals, "character")
    # Length 1
    expect_length(no_intervals, 1)

    # No intervals but partial match
    no_intervals <- build_condition(
        regdb,
        dataset = "GENE",
        filters = list(
            name = c("ara"),
            strand = c("forward")
        ),
        operator = "AND",
        interval = NULL,
        partialmatch = "name"
    )
    # Type character
    expect_type(no_intervals, "character")
    # Length 1
    expect_length(no_intervals, 1)
    # No intervals only partial match
    no_intervals_pm <- build_condition(
        regdb,
        dataset = "GENE",
        filters = list(name = c("ara")),
        operator = NULL,
        interval = NULL,
        partialmatch = "name"
    )
    # Type character
    expect_type(no_intervals_pm, "character")
    # Length 1
    expect_length(no_intervals_pm, 1)
})

test_that("guess_id works ", {
    ## Connect to the RegulonDB database if necessary
    if (!exists("regulondb_conn")) {
          regulondb_conn <- connect_database()
      }

    ## Build a regulondb object
    regdb <-
        regulondb(
            database_conn = regulondb_conn,
            organism = "prueba",
            genome_version = "prueba",
            database_version = "prueba"
        )

    expect_error(guess_id(1, regdb))
    expect_error(guess_id(c("araC", "araG"), regdb))
    expect_length(guess_id("araC", regdb), 1)
    expect_length(guess_id("b0064", regdb), 1)
    expect_length(guess_id("ECK120000050", regdb), 1)
})

test_that("get_gene_synonyms works ", {
    ## Connect to the RegulonDB database if necessary
    if (!exists("regulondb_conn")) {
          regulondb_conn <- connect_database()
      }

    ## Build a regulondb object
    regdb <-
        regulondb(
            database_conn = regulondb_conn,
            organism = "prueba",
            genome_version = "prueba",
            database_version = "prueba"
        )

    expect_s4_class(
        get_gene_synonyms(regdb, "araC", from = "name"),
        "regulondb_result"
    )
    expect_error(get_gene_synonyms(regdb, 2, from = "name"))
    expect_error(get_gene_synonyms(regdb, "araC", from = "namez"))
    expect_error(get_gene_synonyms(regdb, "araC", from = "name", to = "namez"))
    expect_error(get_gene_synonyms(regdb, "araC", from = c("name", "id")))
})

context("get_regulators")
test_that("Functions to retrieve gene regulation work as expected", {
    ## Connect to the RegulonDB database if necessary
    if (!exists("regulondb_conn")) {
          regulondb_conn <- connect_database()
      }

    ## Build a regulondb object
    regdb <-
        regulondb(
            database_conn = regulondb_conn,
            organism = "prueba",
            genome_version = "prueba",
            database_version = "prueba"
        )
    rs1 <- get_gene_regulators(regdb, c("araC", "fis", "crp"))
    expect_s4_class(rs1, "regulondb_result")
    expect_true(metadata(rs1)$format == "multirow")
    rs2 <-
        get_gene_regulators(regdb, c("araC", "fis", "crp"), format = "onerow")
    expect_s4_class(rs2, "regulondb_result")
    expect_true(metadata(rs2)$format == "onerow")
    rs3 <-
        get_gene_regulators(regdb, c("araC", "fis", "crp"), format = "table")
    expect_s4_class(rs3, "regulondb_result")
    expect_true(metadata(rs3)$format == "table")
    expect_s4_class(get_regulatory_network(regdb), "regulondb_result")
    expect_s4_class(
        get_regulatory_summary(regdb, gene_regulators = c("araC", "modB")),
        "regulondb_result"
    )
    expect_error(get_regulatory_summary(regdb, gene_regulators = c(1, 2, 3)))
    regulation_table <-
        get_gene_regulators(regdb,
            genes = c("araC", "modB"),
            format = "table"
        )
    expect_s4_class(
        get_regulatory_summary(regdb, regulation_table),
        "regulondb_result"
    )
    regulation_onerow <-
        get_gene_regulators(regdb,
            genes = c("araC", "modB"),
            format = "onerow"
        )
    expect_s4_class(
        get_regulatory_summary(regdb, regulation_onerow),
        "regulondb_result"
    )

    expect_error(
        get_gene_regulators(regdb, genes = NULL),
        "Parameter 'genes' must be a character vector or list."
    )
    expect_error(
        get_gene_regulators(regdb, genes = c("araC"), output.type = "TFS"),
        "Parameter 'output.type' must be either 'TF' or 'GENE'"
    )
    expect_error(
        get_regulatory_network(regdb, type = "GEN-GENE"),
        "Parameter 'type' must be TF-GENE, TF-TF, or GENE-GENE."
    )
    expect_s4_class(
        get_regulatory_network(regdb, regulator = "Fis"),
        "regulondb_result"
    )
    expect_error(
        get_regulatory_network(regdb, cytograph = TRUE),
        "To use integration with Cytoscape, please launch Cytoscape before running get_regulatory_network()"
    )
})

context("get_gene_regulators")
test_that("function get_gene_regulators works as expected", {
    ## Connect to the RegulonDB database if necessary
    if (!exists("regulondb_conn")) {
          regulondb_conn <- connect_database()
      }

    ## Build a regulondb object
    regdb <-
        regulondb(
            database_conn = regulondb_conn,
            organism = "prueba",
            genome_version = "prueba",
            database_version = "prueba"
        )

    expect_s4_class(
        get_gene_regulators(regdb, genes = "araC"),
        "regulondb_result"
    )
    expect_s4_class(
        get_gene_regulators(regdb, genes = "araC", output.type = "GENE"),
        "regulondb_result"
    )
    expect_s4_class(
        get_gene_regulators(regdb, genes = "araC", format = "table"),
        "regulondb_result"
    )
    expect_s4_class(
        get_gene_regulators(regdb, genes = "araC", format = "onerow"),
        "regulondb_result"
    )

    expect_error(get_gene_regulators(regdb, genes = "araC", format = ""), "")
    expect_error(get_gene_regulators(regdb, genes = c(1, 2)))
    expect_error(get_gene_regulators(regdb, genes = "araC", output.type = "matrix"))

    expect_s4_class(get_gene_regulators(regdb, genes = c("araC", "ECK120000050", "b0064")), "regulondb_result")
})

#' @title Constructs a particular logical condition to query database
#' @description Given a list of filters, this function builds a logical
#' condition to query database using intervals.
#' The output is used in [build_condition()].
#' @author Carmina Barberena Jonás, Jesús Emiliano Sotelo Fonseca,
#' José Alquicira Hernández, Joselyn Chávez
#' @param filters List of filters to be used. The names should correspond to
#' the attribute and the values correspond to the condition for selection.
#' @param interval the filters with values considered as interval.
#' @param partialmatch name of the condition(s) with a string pattern for full
#' or partial match in the query.
#' @param operator A string indicading if all the filters (AND) or some of
#' them (OR) should be met.
#' @return A `character(1)` with the sql logical condition to query the dataset.
#' @examples
#'
#' ## Build the SQL query for existing interval partial matches for ara
#' existing_intervals(
#'     filters = list(
#'         name = "ara",
#'         strand = "for",
#'         posright = c("2000", "40000")
#'     ),
#'     interval = c("posright"),
#'     operator = "AND",
#'     partialmatch = c("name", "strand")
#' )
#' @export


existing_intervals <-
    function(filters, interval, operator, partialmatch) {
        existing.interv.index <- names(filters) %in% interval
        existing.interv <- filters[existing.interv.index]

        # Check that interval's value is a pair
        # If they are more than two, then drop the remaining
        existing.interv <- lapply(existing.interv, function(x) {
            if (length(x) > 2) {
                warning("Only the first two values of interval will be considered.",
                    call. = FALSE
                )
                x[seq_len(2L)]
            } else if (length(x) == 1) {
                stop("Two values in the interval filter are required. ",
                    call. = FALSE
                )
            } else {
                x
            }
        })
        filters[existing.interv.index] <- existing.interv

        condition.format.interv <-
            mapply(paste0, filters[existing.interv.index], "", SIMPLIFY = FALSE)
        condition.format.interv <-
            lapply(condition.format.interv, function(y) {
                paste(c(">=", "<="), y)
            })
        condition.format.interv <-
            mapply(
                paste,
                names(condition.format.interv),
                condition.format.interv,
                sep = " ",
                SIMPLIFY = FALSE
            )
        condition.format.interv <-
            lapply(condition.format.interv, function(x) {
                paste0("(", paste(x, collapse = " AND "), ")")
            })
        condition.interv <-
            paste(unlist(condition.format.interv),
                collapse = paste0(" ", operator, " ")
            )
        if (!is.null(partialmatch)) {
            condition.partialmatch <-
                existing_partial_match(filters, partialmatch, operator)
            condition.pmandin <-
                paste(
                    condition.partialmatch,
                    condition.interv,
                    sep = operator,
                    collapse = operator
                )
            return(condition.pmandin)
        }
        return(condition.interv)
    }

#' @title Constructs a logical condition to query database
#' @description Given a list of filters, this function builds a logical
#' condition to query database using intervals.
#' The output is used in [existing_intervals()] and [non_existing_intervals()].
#' @author Carmina Barberena Jonás, Jesús Emiliano Sotelo Fonseca,
#' José Alquicira Hernández
#' @param filters List of filters to be used. The names should correspond to
#' the attribute and the values correspond to the condition for selection.
#' @param partialmatch name of the condition(s) with a string pattern for full
#' or partial match in the query.
#' @param operator A string indicating if all the filters (AND) or some of them
#' (OR) should be met.
#' @return A `character(1)` with the sql logical condition to query the dataset.
#' @examples
#'
#' ## Build the SQL query for existing partial matches for ara
#' existing_partial_match(
#'     filters = list(
#'         name = c("ara"),
#'         strand = c("forward"),
#'         posright = c("2000", "40000")
#'     ),
#'     partialmatch = "name",
#'     operator = "AND"
#' )
#' @export
existing_partial_match <-
    function(filters, partialmatch, operator) {
        existing.partialmatch.index <- names(filters) %in% partialmatch
        existing.partialmatch <- filters[existing.partialmatch.index]
        condition.format.partialmatch <-
            mapply(paste0, filters[existing.partialmatch.index], "%'",
                SIMPLIFY = FALSE
            )
        condition.format.partialmatch <-
            mapply(
                paste,
                names(condition.format.partialmatch),
                condition.format.partialmatch,
                sep = " like  '%",
                SIMPLIFY = FALSE
            )
        condition.format.partialmatch <-
            lapply(condition.format.partialmatch, function(x) {
                paste0("(", paste(x, collapse = " AND "), ")")
            })
        condition.partialmatch <-
            paste(unlist(condition.format.partialmatch),
                collapse = paste0(" ", operator, " ")
            )
        return(condition.partialmatch)
    }

#' Methods for regulondb objects
#' @name show
#' @aliases show,regulondb-method
#' @param object A regulondb object
#' @docType methods
#' @rdname regulondb-methods
#' @return A [regulondb][regutools::regulondb] object.
setMethod(
    "show",
    signature(object = "regulondb"),
    function(object) {
        cat(
            sprintf(
                paste(
                    "regulondb object\n  organism: %s\n  genome_build:",
                    "%s\n  database_version: %s\n  database_conn: %s\n"
                ),
                object@organism,
                object@genome_version,
                object@database_version,
                object@dbname
            )
        )
    }
)

#' @title Retrieve gene synonyms
#' @description Given a list of genes (id, name, bnumber or gi),
#' get the gene synonyms (name, bnumber of gi).
#' @param regulondb A [regulondb()] object.
#' @param genes Character vector of gene identifiers (id, name, bnumber or gi).
#' @param from A `character()` specifying one of: id, name, bnumber of gi
#' @param to A `character()` specifying one or more of: id, name, bnumber of gi
#' @keywords geneid, bnumber, gi, synonyms
#' @author Jesús Emiliano Sotelo Fonseca
#' @return A [regulondb_result][regutools::regulondb_result-class] object.
#' @examples
#' ## Connect to the RegulonDB database if necessary
#' if (!exists("regulondb_conn")) regulondb_conn <- connect_database()
#'
#' ## Build the regulon db object
#' e_coli_regulondb <-
#'     regulondb(
#'         database_conn = regulondb_conn,
#'         organism = "E.coli",
#'         database_version = "1",
#'         genome_version = "1"
#'     )
#'
#' ## Lists all available identifiers for "araC"
#' get_gene_synonyms(e_coli_regulondb, "araC", from = "name")
#'
#' ## Retrieve only the ID
#' get_gene_synonyms(e_coli_regulondb, "araC", from = "name", to = "id")
#'
#' ## Use an ID to retrieve the synonyms
#' get_gene_synonyms(e_coli_regulondb, "ECK120000998", from = "id")
#' @export

get_gene_synonyms <-
    function(regulondb,
    genes,
    from = "name",
    to = c("id", "name", "bnumber", "gi")) {
        # Function checks
        stopifnot(validObject(regulondb))

        if (length(from) > 1) {
            stop("'from' should be only one of name, bnumber or GI.",
                call. = FALSE
            )
        }

        if (!is(genes, "character")) {
            stop("'genes' should be a character vector of gene identifiers.",
                call. = FALSE
            )
        }

        if (!all(to %in% c("id", "name", "bnumber", "gi"))) {
            stop(
                paste(
                    "'to' should be a character vector with one or more",
                    "of name, bnumber or GI."
                ),
                call. = FALSE
            )
        }

        if (!from %in% c("id", "name", "bnumber", "gi")) {
            stop("'from' should be one or more of name, bnumber or GI.",
                call. = FALSE
            )
        }

        gene_filter <- list(genes)
        names(gene_filter) <- from

        # Convert GIs to gene names
        gene_synonyms <-
            get_dataset(
                regulondb,
                dataset = "GENE",
                attributes = to,
                filters = gene_filter
            )

        return(gene_synonyms)
    }

#' @title Get the binding sites for a Transcription Factor (TF)
#' @description Retrieve the binding sites and genome location for a given
#' transcription factor.
#' @author José Alquicira Hernández, Jacques van Helden, Joselyn Chávez
#' @param regulondb A [regulondb()] object.
#' @param transcription_factor name of the transcription factor.
#' @param output_format The output object. Can be either a `GRanges` (default)
#'  or `Biostrings`.
#' @return Either a GRanges object or a Biostrings object summarizing
#' information
#' about the binding sites of the transcription factors.
#' @examples
#' ## Connect to the RegulonDB database if necessary
#' if (!exists("regulondb_conn")) regulondb_conn <- connect_database()
#'
#' ## Build the regulon db object
#' e_coli_regulondb <-
#'     regulondb(
#'         database_conn = regulondb_conn,
#'         organism = "E.coli",
#'         database_version = "1",
#'         genome_version = "1"
#'     )
#'
#' ## Get the binding sites for AraC
#' get_binding_sites(e_coli_regulondb, transcription_factor = "AraC")
#' @export
get_binding_sites <- function(regulondb, transcription_factor,
    output_format = "GRanges") {
    ## For a BiocCheck NOTE
    left <- right <- NULL
    if (!output_format %in% c("GRanges", "Biostrings")) {
        stop("The parameter 'output_format' must be either 'GRanges' or 'Biostrings'")
    }
    stopifnot(validObject(regulondb))
    tfbs_raw <- get_dataset(
        regulondb = regulondb,
        dataset = "TF",
        attributes = c("name", "tfbs_unique"),
        filters = list(name = transcription_factor)
    )
    if (nrow(tfbs_raw) == 0) {
        return(NULL)
    }
    tfbs_table <-
        as.data.frame(
            strsplit(x = tfbs_raw$tfbs_unique, split = " "),
            col.names = "res"
        )
    tfbs_table <- strsplit(
        as.character(tfbs_table$res),
        split =  "\t"
    )
    tfbs_table <- as.data.frame(do.call(rbind, tfbs_table))
    colnames(tfbs_table) <-
        c("ID", "left", "right", "strand", "sequence")
    tfbs_table$left <- as.numeric(as.character(tfbs_table$left))
    tfbs_table$right <- as.numeric(as.character(tfbs_table$right))
    tfbs_table$strand <- ifelse(tfbs_table$strand == "forward", "+", "-")
    tfbs_table$strand[is.na(tfbs_table$strand)] <- "*"
    if (output_format == "GRanges") {
        res <- with(
            tfbs_table,
            GRanges(tfbs_raw@organism,
                IRanges(start = left, end = right),
                strand = strand
            )
        )
        names(res) <- as.character(tfbs_table$ID)
        mcols(res)$sequence <- as.character(tfbs_table$sequence)
        res
    } else {
        res <- DNAStringSet(as.character(tfbs_table$sequence))
        names(res) <- as.character(tfbs_table$ID)
        mcols(res)$granges <- with(
            tfbs_table,
            GRanges(tfbs_raw@organism,
                IRanges(start = left, end = right),
                strand = strand
            )
        )
        res
    }
}

#' @title Return summary of gene regulation.
#' @description This function takes the output of [get_gene_regulators()] with
#' format multirow,
#' onerow or table, or a vector with genes and retrieves information about the
#' TFs and their regulated genes
#' @param regulondb A [regulondb()] object.
#' @param gene_regulators Result from [get_gene_regulators()] or vector of
#'  genes
#' @return A data frame with the following columns:
#' \itemize{
#' \item The name or gene of TF
#' \item Regulated Genes per TF
#' \item Percent of regulated genes per TF
#' \item positive, negative or dual regulation
#' \item Name(s) of regulated genes
#' }
#' @keywords regulation retrieval, summary, networks,
#' @author Carmina Barberena Jonas, Jesús Emiliano Sotelo Fonseca,
#' José Alquicira Hernández, Joselyn Chávez
#' @examples
#' ## Connect to the RegulonDB database if necessary
#' if (!exists("regulondb_conn")) regulondb_conn <- connect_database()
#'
#' ## Build the regulon db object
#' e_coli_regulondb <-
#'     regulondb(
#'         database_conn = regulondb_conn,
#'         organism = "E.coli",
#'         database_version = "1",
#'         genome_version = "1"
#'     )
#'
#' ## Get the araC regulators
#' araC_regulation <-
#'     get_gene_regulators(
#'         e_coli_regulondb,
#'         genes = c("araC"),
#'         format = "multirow",
#'         output.type = "TF"
#'     )
#'
#' ## Summarize the araC regulation
#' get_regulatory_summary(e_coli_regulondb, araC_regulation)
#'
#' ## Retrieve summary of genes 'araC' and 'modB'
#' get_regulatory_summary(e_coli_regulondb,
#'     gene_regulators = c("araC", "modB")
#' )
#'
#' ## Obtain the summary for 'ECK120000050' and 'modB'
#' get_regulatory_summary(e_coli_regulondb,
#'     gene_regulators = c("ECK120000050", "modB")
#' )
#' @export
#' @importFrom stats complete.cases

get_regulatory_summary <- function(regulondb, gene_regulators) {
    regulation <- gene_regulators
    # Check that class is regulation or character

    # Regulation of a gene list
    if (is(regulation, "character")) {
        regulation <- get_gene_regulators(regulondb, genes = regulation)
    } else if (!is(regulation, "regulondb_result")) {
        stop(
            paste(
                "The parameter gene_regulators must be a regulondb_result",
                "object resulting from a call to get_gene_regulators",
                "or a vector of genes."
            ),
            call. = FALSE
        )
    }

    # Conver onerow to multirow
    if (metadata(regulation)$format == "onerow") {
        regulation <-
            get_gene_regulators(regulondb,
                genes = as.character(regulation$genes)
            )
    }

    # Convert table to multirow
    if (metadata(regulation)$format == "table") {
        regulation <- get_gene_regulators(regulondb,
            genes = as.character(rownames(regulation))
        )
    }

    TF_counts <-
        data.frame(table(regulation$regulators), stringsAsFactors = FALSE)

    summary <- apply(TF_counts, 1, function(x) {
        # Get rows for a specific TF
        TF_data <- regulation[regulation[, "regulators"] == x[1], ]

        # Count regulated effects
        effect <- table(TF_data$effect)
        # Adds regulation +, - or +/- in case their frequency is 0.
        if (!"+" %in% names(effect)) {
            effect <- c(effect, "+" = 0)
        }
        if (!"-" %in% names(effect)) {
            effect <- c(effect, "-" = 0)
        }
        if (!"+/-" %in% names(effect)) {
            effect <- c(effect, "+/-" = 0)
        }

        # Concatenates row to include the summary information for each TF
        summary_row <- c(
            TF = x[1],
            # TF name
            regulated_number = x[2],
            # Number of genes regulated per TF
            regulated_percentage =
                (as.numeric(x[2]) / length(regulation$genes)) * 100,
            # Percent of genes in query regulated per TF
            activator = effect["+"],
            # Frequency of activation interactions
            repressor = effect["-"],
            # Frequency of repression interactions
            dual = effect["+/-"],
            # Frequency of dual interactions
            regulated = paste(TF_data$genes,
                collapse = ", "
            ) # List of genes regulated per TF
        )

        return(summary_row)
    })

    summary <- data.frame(t(summary)) # Format summary as a data.frame
    colnames(summary) <-
        c(
            "TF",
            "Regulated_genes_per_TF",
            "Percent",
            "Activator",
            "Repressor",
            "Dual",
            "Regulated_genes"
        )

    summary <- dataframe_to_dbresult(summary, regulondb, "NETWORK")
    return(summary)
}

#' @title Construct logical condition to query database
#' @description Given a list of filters, this function builds a logical
#' condition to query database.
#' The output is used in [get_dataset()].
#' @author Carmina Barberena Jonás, Jesús Emiliano Sotelo Fonseca,
#' José Alquicira Hernández, Joselyn Chávez
#'
#' @param dataset dataset of interest
#' @param filters List of filters to be used. The names should correspond to
#' the attribute and the values correspond to the condition for selection.
#' @param operator A string indicating if all the filters (AND) or some of them
#' (OR) should be met
#' @param interval the filters with values considered as interval
#' @param regulondb A [regulondb()] object.
#' @param partialmatch name of the condition(s) with a string pattern for full
#' or partial match in the query
#'
#' @return A `character(1)` with the sql logical condition to query the dataset
#' .
#' @examples
#'
#' ## Connect to the RegulonDB database if necessary
#' if (!exists("regulondb_conn")) regulondb_conn <- connect_database()
#'
#' ## Build the regulon db object
#' e_coli_regulondb <-
#'     regulondb(
#'         database_conn = regulondb_conn,
#'         organism = "E.coli",
#'         database_version = "1",
#'         genome_version = "1"
#'     )
#'
#' ## Build the condition for ara
#' build_condition(
#'     e_coli_regulondb,
#'     dataset = "GENE",
#'     filters = list(
#'         name = c("ara"),
#'         strand = c("forward"),
#'         posright = c("2000", "40000")
#'     ),
#'     operator = "AND",
#'     interval = "posright",
#'     partialmatch = "name"
#' )
#' @export

build_condition <-
    function(regulondb,
    dataset,
    filters,
    operator,
    interval,
    partialmatch) {
        if (is(filters, "list")) {
            if (!all(names(filters) %in% list_attributes(regulondb, dataset))) {
                non.existing.attrs.index <-
                    names(filters) %in% list_attributes(regulondb, dataset)
                non.existing.attrs <-
                    names(filters)[!non.existing.attrs.index]
                stop("Attribute(s) ",
                    non.existing.attrs,
                    " do not exist.",
                    call. = FALSE
                )
            }
            if (!is.null(interval)) {
                if (!all(interval %in% names(filters))) {
                    non.existing.interv.index <-
                        !(interval %in% names(filters))
                    non.existing.interv <-
                        (interval[non.existing.interv.index])
                    stop(
                        "Intervals ",
                        paste0(
                            '"',
                            paste(non.existing.interv, collapse = ", "),
                            '"'
                        ),
                        " do not exist in the filters you provided",
                        call. = FALSE
                    )
                }

                condition_intervals <-
                    existing_intervals(
                        filters, interval,
                        operator, partialmatch
                    )
                if ((length(filters) == length(interval))) {
                    condition_intervals <-
                        existing_intervals(
                            filters, interval,
                            operator, partialmatch
                        )
                    return(condition_intervals)
                } else {
                    # non-equal case
                    conditions_nonintervals <-
                        non_existing_intervals(
                            filters, interval,
                            operator, partialmatch
                        )
                    conditionall <-
                        paste(condition_intervals,
                            conditions_nonintervals,
                            sep = " AND "
                        )
                    return(conditionall)
                }
            } else {
                # NULL case
                conditions_nonintervals <-
                    non_existing_intervals(
                        filters, interval,
                        operator, partialmatch
                    )
                return(conditions_nonintervals)
            }
        } else {
            stop("The argument filters is not a list", call. = FALSE)
        }
    }

#' @title The regulondb class
#' @description The regulondb class is an extension of the SQLiteConnection,
#' which as the name suggests, consists of an SQLite connection to a database
#' with the table design of the
#' RegulonDb database. In addition to the slots defined in the
#' SQLiteConnection object,
#' the regulondb class also contains additional slots to store
#' information about database versions, organism information and genome build
#' versions.
#' @slot organism A character vector with the name of the organism of the
#' database.
#' @slot genome_version A character vector with the version of the genome
#' build.
#' @slot database_version A character vector with the version of regulondb
#' build.
#' @export
#' @import RSQLite
#' @importFrom methods is new validObject
setClass(
    "regulondb",
    contains = "SQLiteConnection",
    slots = list(
        organism = "character",
        genome_version = "character",
        database_version = "character"
    )
)

setValidity("regulondb", function(object) {
    table_must <- c(
        "DNA_OBJECTS",
        "GENE",
        "NETWORK",
        "OPERON",
        "PROMOTER",
        "REGULONDB_OBJECTS",
        "TF",
        "TU"
    )
    if (!all(table_must %in% dbListTables(object))) {
        table_must <- table_must[!table_must %in% dbListTables(object)]
        flg <- length(table_must) > 1
        sprintf(
            "The following table%s %s missing from the database: %s",
            ifelse(flg, "s", ""),
            ifelse(flg, "are", "is"),
            ifelse(flg, paste(table_must, collapse = ", "), table_must)
        )
    } else if (!is(object@organism, "character")) {
        "The slot 'organism' name must be a character vector"
    } else if (!is(object@database_version, "character")) {
        "The slot 'database_version' must be a character vector"
    } else if (!is(object@genome_version, "character")) {
        "The slot 'genome_version' name must be a character vector"
    } else {
        TRUE
    }
})

#' Constructor function of a regulondb class
#' @aliases build_regulondb
#' @description The build_regulondb function is a constructor function of a
#' regulondb class.
#' @param database_conn A
#' [SQLiteConnection-class][RSQLite::SQLiteConnection-class] connection to
#' the RegulonDB database made with [connect_database()].
#' @param organism A character vector with the name of the organism of the
#' database.
#' @param genome_version A character vector with the version of the genome
#' build.
#' @param database_version A character vector with the version of regulondb
#' build.
#' @return A [regulondb][regutools::regulondb] object.
#' @examples
#'
#' ## Connect to the RegulonDB database if necessary
#' if (!exists("regulondb_conn")) regulondb_conn <- connect_database()
#'
#' ## Build a regulondb object
#' e_coli_regulondb <-
#'     regulondb(
#'         database_conn = regulondb_conn,
#'         organism = "E.coli",
#'         database_version = "1",
#'         genome_version = "1"
#'     )
#' @export
regulondb <-
    function(database_conn,
    organism,
    genome_version,
    database_version) {
        stopifnot(is(database_conn, "SQLiteConnection"))
        stopifnot(is(organism, "character"))
        stopifnot(is(genome_version, "character"))
        stopifnot(is(database_version, "character"))
        new(
            "regulondb",
            database_conn,
            organism = organism,
            genome_version = genome_version,
            database_version = database_version
        )
    }

#' @title The regulondb_results class
#' @description The regulondb class is an extension of the DataFrame class,
#' with
#' additional slots that host information of the database used to obtain these
#' results.
#' @slot organism A character string with the name of the organism of the
#' database.
#' @slot genome_version A character string with the version of the genome
#' build.
#' @slot database_version A character string with the version of regulondb
#' build.
#' @slot dataset A character string with the name of the table used for the
#' query in get_dataset().
#' @importClassesFrom S4Vectors DFrame
#' @export
setClass(
    "regulondb_result",
    contains = "DFrame",
    slots = list(
        organism = "character",
        genome_version = "character",
        database_version = "character",
        dataset = "character"
    )
)

setValidity("regulondb_result", function(object) {
    if (!is(object@organism, "character")) {
        "The slot 'organism' name must be a character vector"
    } else if (!is(object@database_version, "character")) {
        "The slot 'database_version' must be a character vector"
    } else if (!is(object@genome_version, "character")) {
        "The slot 'genome_version' name must be a character vector"
    } else if (!is(object@dataset, "character")) {
        "The slot 'dataset' name must be a character vector"
    } else {
        TRUE
    }
})

#' @title Guess gene id type
#' @description Given a gene identifier, return the most likely gene_id type.
#' @param gene Character vector of gene identifiers (id, name, bnumber or gi).
#' @param regulondb A [regulondb()] object.
#' @keywords geneid, bnumber, gi, synonyms
#' @author Jesús Emiliano Sotelo Fonseca
#' @return A `character(1)` vector with the name column guessed value.
#' @examples
#' ## Connect to the RegulonDB database if necessary
#' if (!exists("regulondb_conn")) regulondb_conn <- connect_database()
#'
#' ## Build the regulon db object
#' e_coli_regulondb <-
#'     regulondb(
#'         database_conn = regulondb_conn,
#'         organism = "E.coli",
#'         database_version = "1",
#'         genome_version = "1"
#'     )
#'
#' ## Lists all available identifiers for "araC"
#' ## Guess name
#' guess_id("araC", e_coli_regulondb)
#'
#' ## Guess id
#' guess_id("ECK120000050", e_coli_regulondb)
#'
#' ## Guess bnumber
#' guess_id("b0064", e_coli_regulondb)
#' @export

guess_id <- function(gene, regulondb) {
    # Function checks
    stopifnot(validObject(regulondb))

    if (!is(gene, "character")) {
        stop("'genes' should be a character vector of gene identifiers.",
            call. = FALSE
        )
    }
    if (length(gene) > 1) {
        stop("'genes' should be a character vector of length one",
            call. = FALSE
        )
    }

    gene_id_type <- "name"

    # Guess bnumber
    if (grepl("^b[0-9]", gene)) {
        gene_id_type <- "bnumber"
        return(gene_id_type)
    }
    # Guess id
    if (grepl("(eck|ECK)12", gene)) {
        gene_id_type <- "id"
        # Guess name
    } else if (grepl("[a-z]", gene)) {
        gene_id_type <- "name"
    }

    return(gene_id_type)
}

#' @title Get TFs or genes that regulate the genes of interest
#' @description Given a list of genes (name, bnumber or GI),
#' get all transcription factors or genes that regulate them.
#' The effect of regulators over the gene of interest can be positive (+),
#' negative (-) or dual (+/-)
#' @param regulondb A regulondb class.
#' @param genes Vector of genes (name, bnumber or GI).
#' @param format Output format: multirow, onerow, table
#' @param output.type How regulators will be represented: "TF"/"GENE"
#' @keywords regulation retrieval, TFs, networks,
#' @author Carmina Barberena Jonas, Jesús Emiliano Sotelo Fonseca,
#' José Alquicira Hernández, Joselyn Chávez
#' @return A [regulondb_result][regutools::regulondb_result-class] object.
#' @examples
#' ## Connect to the RegulonDB database if necessary
#' if (!exists("regulondb_conn")) regulondb_conn <- connect_database()
#'
#' ## Build the regulon db object
#' e_coli_regulondb <-
#'     regulondb(
#'         database_conn = regulondb_conn,
#'         organism = "E.coli",
#'         database_version = "1",
#'         genome_version = "1"
#'     )
#'
#' ## Get Transcription factors that regulate araC in one row
#' get_gene_regulators(
#'     e_coli_regulondb,
#'     genes = c("araC"),
#'     output.type = "TF",
#'     format = "onerow"
#' )
#'
#' ## Get genes that regulate araC in table format
#' get_gene_regulators(
#'     e_coli_regulondb,
#'     genes = c("araC"),
#'     output.type = "GENE",
#'     format = "table"
#' )
#' @export

get_gene_regulators <-
    function(regulondb,
    genes,
    format = "multirow",
    output.type = "TF") {
        stopifnot(validObject(regulondb))
        # Check genes parameter class
        ##        if (!class(genes) %in% c("vector", "list", "character")) {
        if (!(is(genes, "vector") | is(genes, "list") | is(genes, "character")
        )) {
            stop("Parameter 'genes' must be a character vector or list.",
                call. = FALSE
            )
        }
        # Check format parameter
        if (!format %in% c("multirow", "onerow", "table")) {
            stop("Parameter 'format' must be multirow, onerow, or table.",
                call. = FALSE
            )
        }
        # Check output.type
        if (!output.type %in% c("TF", "GENE")) {
            stop("Parameter 'output.type' must be either 'TF' or 'GENE'",
                call. = FALSE
            )
        }

        # Convert GIs to gene names
        # Assign id per gene
        gene_guesses <- vapply(genes, guess_id,
            regulondb = regulondb,
            FUN.VALUE = character(1)
        )

        # Check that guesses are names

        if (!all(gene_guesses == "name")) {
            split_ids <- split(x = genes, f = gene_guesses)

            # Get synonyms for each group
            names_list <- lapply(names(split_ids), function(id) {
                get_gene_synonyms(regulondb,
                    genes = split_ids[[id]],
                    from = id,
                    to = "name"
                )[["name"]]
            })
            # Cat id list
            genes <- unlist(names_list)
            names(genes) <- NULL
        }

        # Checks for type of network
        if (output.type == "TF") {
            network.type <- "TF-GENE"
        } else if (output.type == "GENE") {
            network.type <- "GENE-GENE"
        }

        # Retrieve data from NETWORK table
        regulation <-
            as.data.frame(get_dataset(
                regulondb,
                attributes = c("regulated_name", "regulator_name", "effect"),
                filters = list(
                    "regulated_name" = genes,
                    "network_type" = network.type
                ),
                dataset = "NETWORK"
            ))
        colnames(regulation) <- c("genes", "regulators", "effect")

        # Change effect to +, - and +/-
        regulation$effect <-
            sub(
                pattern = "activator",
                replacement = "+",
                x = regulation$effect
            )
        regulation$effect <-
            sub(
                pattern = "repressor",
                replacement = "-",
                x = regulation$effect
            )
        regulation$effect <-
            sub(
                pattern = "dual",
                replacement = "+/-",
                x = regulation$effect
            )

        # Format output
        # Multirow
        if (format == "multirow") {
            # Add internal attribute "format" to use in GetSummary function.
            regulation <-
                dataframe_to_dbresult(regulation, regulondb, "NETWORK")
            metadata(regulation)$format <- format
            return(regulation)

            # Onerow
        } else if (format == "onerow") {
            regulation <- lapply(as.list(genes), function(x) {
                genereg <- regulation[regulation[, "genes"] == x, ]
                genereg <-
                    paste(
                        paste(
                            genereg$regulators,
                            genereg$effect,
                            sep = "(",
                            collapse = "), "
                        ),
                        ")",
                        sep = ""
                    )
            })
            regulation <- unlist(regulation)
            genes <- unlist(genes)
            regulation <- data.frame(genes, regulation)
            colnames(regulation) <- c("genes", "regulators")

            # Add internal attribute "format" to use in GetSummary function.
            regulation <-
                dataframe_to_dbresult(regulation, regulondb, "NETWORK")
            metadata(regulation)$format <- format
            return(regulation)

            # Table
        } else if (format == "table") {
            # Empty dataframe
            rtable <-
                data.frame(matrix(nrow = length(genes), ncol = length(c(
                    unique(regulation$regulators)
                ))))
            colnames(rtable) <- unique(regulation$regulators)
            rownames(rtable) <- genes

            # Fill dataframe with regulation
            for (i in seq_len(dim(regulation)[1])) {
                rtable[regulation[i, 1], regulation[i, 2]] <- regulation[i, 3]
            }
            regulation <- rtable

            # Add internal attribute "format" to use in GetSummary function.
            regulation <-
                dataframe_to_dbresult(regulation, regulondb, "NETWORK")
            metadata(regulation)$format <- format
            return(regulation)
        }
    }

#' @title List attributes/fields from a dataset/table
#' @description List all attributes and their description of a dataset from
#' RegulonDB. The result of this function may
#' be used as parameter 'values' in [list_attributes()] function.
#' @author Carmina Barberena Jonás, Jesús Emiliano Sotelo Fonseca,
#' José Alquicira Hernández, Joselyn Chavez
#' @keywords data retrieval, attributes
#' @param regulondb A [regulondb()] object.
#' @param dataset Dataset of interest. The name should correspond to a table of
#' the database.
#' @return A character vector with the field names.
#' @examples
#' ## Connect to the RegulonDB database if necessary
#' if (!exists("regulondb_conn")) regulondb_conn <- connect_database()
#'
#' ## Build the regulon db object
#' e_coli_regulondb <-
#'     regulondb(
#'         database_conn = regulondb_conn,
#'         organism = "E.coli",
#'         database_version = "1",
#'         genome_version = "1"
#'     )
#'
#' ## List the transcription factor attributes
#' list_attributes(e_coli_regulondb, "TF")
#'
#' ## List the operon attributes
#' list_attributes(e_coli_regulondb, "OPERON")
#' @export
#' @importFrom DBI dbListFields

list_attributes <- function(regulondb, dataset) {
    if (missing(dataset)) {
          stop("Parameter 'dataset' is missing, please specify\n")
      }
    stopifnot(validObject(regulondb))
    dbListFields(regulondb, dataset)
}

#' @title List available datasets in RegulonDB database
#' @description  This function returns a vector of all available tables from a
#' regulondb class.
#' @param regulondb A regulondb class.
#' @keywords data retrieval datasets database
#' @return A `character()` with the names of the available datasets.
#' @examples
#'
#' ## Connect to the RegulonDB database if necessary
#' if (!exists("regulondb_conn")) regulondb_conn <- connect_database()
#'
#' ## Build the regulon db object
#' e_coli_regulondb <-
#'     regulondb(
#'         database_conn = regulondb_conn,
#'         organism = "E.coli",
#'         database_version = "1",
#'         genome_version = "1"
#'     )
#'
#' ## List the available datasets
#' list_datasets(e_coli_regulondb)
#' @export
list_datasets <- function(regulondb) {
    stopifnot(validObject(regulondb))
    dbListTables(regulondb)
}

#' @title Constructs a logical condition to query database
#' @description Given a list of filters, this function builds a logical
#' condition to query database using intervals.
#' The output is used in [build_condition()].
#' @author Carmina Barberena Jonás, Jesús Emiliano Sotelo Fonseca,
#' José Alquicira Hernández
#' @param interval the filters whose values will be considered as interval
#' @inheritParams existing_partial_match
#' @return A `character(1)` with the sql logical condition to query the dataset.
#' @examples
#' ## Build the SQL query for finidng non-existing intervals for the gene ara
#' non_existing_intervals(
#'     filters = list(name = "ara", strand = "for"),
#'     interval = NULL,
#'     operator = "AND",
#'     partialmatch = c("name", "strand")
#' )
#' @export

non_existing_intervals <-
    function(filters, interval, operator, partialmatch) {
        if (!(length(partialmatch) + length(interval) == length(filters))) {
            non.interv.index <-
                !((names(filters) %in% interval) | (names(filters) %in%
                    partialmatch))
            non.interv <- filters[non.interv.index]
            condition.format.non.interv <-
                mapply(paste0, filters[non.interv.index], "'", SIMPLIFY = FALSE)
            condition.format.non.interv <-
                mapply(
                    paste,
                    names(condition.format.non.interv),
                    condition.format.non.interv,
                    sep = " = '",
                    SIMPLIFY = FALSE
                )
            condition.format.non.interv <-
                lapply(condition.format.non.interv, function(x) {
                    paste0("(", paste(x, collapse = " OR "), ")")
                })
            condition.non.interv <-
                paste(unlist(condition.format.non.interv),
                    collapse = paste0(" ", operator, " ")
                )
        }
        if (!is.null(partialmatch)) {
            condition.partialmatch <-
                existing_partial_match(filters, partialmatch, operator)
            if ((length(partialmatch) + length(interval) == length(filters))) {
                return(condition.partialmatch)
            } else {
                condition.partialmatch <-
                    existing_partial_match(filters, partialmatch, operator)
                condition.pmandnoin <-
                    paste(
                        condition.partialmatch,
                        condition.non.interv,
                        sep = operator,
                        collapse = operator
                    )
                return(condition.pmandnoin)
            }
        } else {
            return(condition.non.interv)
        }
    }

#' Plot annotation elements within genomic region
#'
#' @param regulondb A [regulondb()] object.
#' @param genome A valid UCSC genome name.
#' @param grange A [GenomicRanges::GRanges-class()] object indicating position
#' left and right.
#' @param elements A character vector specifying which annotation elements to
#' plot. It can be any from: `"-10 promoter box"`, `"-35 promoter box"`,
#' `"gene"`, `"promoter"`, `"Regulatory Interaction"`, `"sRNA interaction"`,
#' or `"terminator"`.
#'
#' @author Joselyn Chavez
#' @return A plot with genomic elements found within a genome region,
#' including genes and regulators.
#' @importFrom Gviz GeneRegionTrack plotTracks GenomeAxisTrack AnnotationTrack
#' @importFrom GenomicRanges GRanges
#' @importFrom IRanges IRanges
#' @examples
#' ## Connect to the RegulonDB database if necessary
#' if (!exists("regulondb_conn")) {
#'       regulondb_conn <- connect_database()
#'   }
#'
#' ## Build the regulondb object
#' e_coli_regulondb <-
#'     regulondb(
#'         database_conn = regulondb_conn,
#'         organism = "chr",
#'         database_version = "1",
#'         genome_version = "1"
#'     )
#'
#' ## Plot some genes from E. coli using default parameters
#' plot_dna_objects(e_coli_regulondb)
#'
#' ## Plot genes providing Genomic Ranges
#' grange <- GenomicRanges::GRanges(
#'     "chr",
#'     IRanges::IRanges(5000, 10000)
#' )
#' plot_dna_objects(e_coli_regulondb, grange)
#'
#' ## Plot aditional elements within genomic positions
#' plot_dna_objects(e_coli_regulondb,
#'     grange,
#'     elements = c("gene", "promoter")
#' )
#' @export
plot_dna_objects <-
    function(regulondb,
    genome = "eschColi_K12",
    grange = GRanges("chr", IRanges(1, 5000)),
    elements = "gene") {
        valid_elements <- c(
            "-10 promoter box",
            "-35 promoter box",
            "gene",
            "promoter",
            "Regulatory Interaction",
            "sRNA interaction",
            "terminator"
        )
        # Validate elements
        if (!all(elements %in% valid_elements)) {
            non.valid.elements.index <- elements %in% valid_elements
            non.valid.elements <- elements[!non.valid.elements.index]
            stop(
                "Element(s) ",
                paste0('"', paste(non.valid.elements, collapse = ", "), '"'),
                paste(
                    " are not valid. Please provide any or all of these",
                    "valid elements: "
                ),
                paste0('"', paste(valid_elements, collapse = ", "), '"'),
                call. = FALSE
            )
        }
        # search for dna_objects ("-10 promoter box", -35 promoter box",
        # "gene", "promoter", "Regulatory Interaction","sRNA interaction",
        # "terminator")
        dna_objects <- regutools::get_dataset(
            regulondb,
            dataset = "DNA_OBJECTS",
            filters = list(
                posright = c(
                    grange@ranges@start,
                    grange@ranges@start +
                        grange@ranges@width
                ),
                type = elements
            ),
            interval = "posright",
            output_format = "GRanges"
        )

        # set dna_object 'gene' as first element
        dna_objects_type <- unique(sort(dna_objects$type))
        if (grep("gene", dna_objects_type) > 0) {
            dna_objects_type <-
                c("gene", dna_objects_type[!dna_objects_type == "gene"])
        }

        # build tracks
        build_track <- function(x) {
            # select data with type == element
            object_filtered <- dna_objects[dna_objects$type == x]
            # build track
            Gviz::AnnotationTrack(object_filtered,
                genome,
                chromosome = "chr",
                name = x,
                options(ucscChromosomeNames = TRUE),
                transcriptAnnotation = "name",
                background.panel = "#FFFEDB",
                background.title = "brown",
                fontsize = 10
            )
        }

        list_dna_annotation <- lapply(dna_objects_type, build_track)

        # plot
        Gviz::plotTracks(c(
            Gviz::GenomeAxisTrack(),
            list_dna_annotation
        ))
    }

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>"
)

## ----vignetteSetup, echo=FALSE, message=FALSE, warning = FALSE----------------
## For links
library("BiocStyle")

## Track time spent on making the vignette
startTime <- Sys.time()

## Bib setup
library("RefManageR")

## Write bibliography information
bib <- c(
    R = citation(),
    AnnotationDbi = citation("AnnotationDbi"),
    AnnotationHub = citation("AnnotationHub"),
    BiocFileCache = citation("BiocFileCache"),
    BiocStyle = citation("BiocStyle"),
    Biostrings = citation("Biostrings"),
    DBI = citation("DBI"),
    GenomicRanges = citation("GenomicRanges"),
    Gviz = citation("Gviz"),
    IRanges = citation("IRanges"),
    knitr = citation("knitr")[3],
    RCy3 = citation("RCy3"),
    RefManageR = citation("RefManageR")[1],
    regutools = citation("regutools")[1],
    regutoolsPaper = citation("regutools")[2],
    rmarkdown = citation("rmarkdown")[1],
    RSQLite = citation("RSQLite"),
    S4Vectors = citation("S4Vectors"),
    sessioninfo = citation("sessioninfo"),
    testthat = citation("testthat")
)

## ----'install', eval = FALSE--------------------------------------------------
# if (!requireNamespace("BiocManager", quietly = TRUE)) {
#       install.packages("BiocManager")
#   }
# 
# BiocManager::install("regutools")
# 
# ## Check that you have a valid Bioconductor installation
# BiocManager::valid()

## ----'citation'---------------------------------------------------------------
## Citation info
citation("regutools")

## ----'connect_db', echo = TRUE, message=FALSE---------------------------------
library("regutools")

## Other packages used
library("Biostrings")

## Connect to the RegulonDB database
regulondb_conn <- connect_database()

## Build a regulondb object
e_coli_regulondb <-
    regulondb(
        database_conn = regulondb_conn,
        organism = "E.coli",
        database_version = "1",
        genome_version = "1"
    )

e_coli_regulondb

## ----'list_datasets', echo = TRUE---------------------------------------------
list_datasets(e_coli_regulondb)

## ----'list_attr'--------------------------------------------------------------
head(list_attributes(e_coli_regulondb, "GENE"), 8)

## ----'get_dataset', echo = TRUE-----------------------------------------------
get_dataset(
    regulondb = e_coli_regulondb,
    dataset = "GENE",
    attributes = c("posleft", "posright", "strand", "name"),
    filters = list("name" = c("araC", "crp", "lacI"))
)

## ----'get_dataset_interval', echo = TRUE--------------------------------------
get_dataset(
    e_coli_regulondb,
    attributes = c("posright", "name"),
    filters = list("posright" = c(1, 5000)),
    interval = "posright",
    dataset = "GENE"
)

## ----'get_dataset_DF'---------------------------------------------------------
res <- get_dataset(
    regulondb = e_coli_regulondb,
    dataset = "GENE",
    attributes = c("posleft", "posright", "strand", "name"),
    filters = list("name" = c("araC", "crp", "lacI"))
)
slotNames(res)

## ----'convert_granges'--------------------------------------------------------
convert_to_granges(res)

## ----'get_dataset_GRanges'----------------------------------------------------
get_dataset(
    regulondb = e_coli_regulondb,
    dataset = "GENE",
    attributes = c("posleft", "posright", "strand", "name"),
    filters = list("name" = c("araC", "crp", "lacI")),
    output_format = "GRanges"
)

## ----'dnastring_res'----------------------------------------------------------
res_dnastring <- get_dataset(
    regulondb = e_coli_regulondb,
    dataset = "GENE",
    attributes = c("posleft", "posright", "strand", "name", "dna_sequence"),
    filters = list("name" = c("araC", "crp", "lacI"))
)
res_dnastring <-
    convert_to_biostrings(res_dnastring, seq_type = "DNA")
res_dnastring
GenomicRanges::mcols(res_dnastring)

## ----'product_seq'------------------------------------------------------------
res_prodstring <- get_dataset(
    regulondb = e_coli_regulondb,
    dataset = "GENE",
    attributes = c("posleft", "posright", "strand", "name", "product_sequence"),
    filters = list("name" = c("araC", "crp", "lacI"))
)
res_prodstring <-
    convert_to_biostrings(res_prodstring, seq_type = "product")
mcols(res_prodstring)

## ----'partial_match', echo = TRUE---------------------------------------------
get_dataset(
    e_coli_regulondb,
    attributes = c("posright", "name"),
    filters = list("name" = "ara"),
    partialmatch = "name",
    dataset = "GENE"
)

## ----'position_interval', echo = TRUE-----------------------------------------
get_dataset(
    e_coli_regulondb,
    attributes = c("name", "strand", "posright", "product_name"),
    dataset = "GENE",
    filters = list(posright = c("2000", "4000000")),
    interval = "posright"
)

## ----'genomic_elements', echo = TRUE------------------------------------------
get_dna_objects(e_coli_regulondb)

## ----'especific_ranges', echo = TRUE------------------------------------------
grange <- GenomicRanges::GRanges(
    "chr",
    IRanges::IRanges(5000, 10000)
)
get_dna_objects(e_coli_regulondb, grange)

## ----'aditional_elements', echo = TRUE----------------------------------------
grange <- GenomicRanges::GRanges(
    "chr",
    IRanges::IRanges(5000, 10000)
)
get_dna_objects(e_coli_regulondb, grange, elements = c("gene", "promoter"))

## ----'plot_elements', echo = TRUE---------------------------------------------
e_coli_regulondb <-
    regulondb(
        database_conn = regulondb_conn,
        organism = "chr",
        database_version = "1",
        genome_version = "1"
    )

grange <- GenomicRanges::GRanges("chr", IRanges::IRanges(5000, 10000))
plot_dna_objects(e_coli_regulondb, grange, elements = c("gene", "promoter"))

## ----'complex_filter'---------------------------------------------------------
nrow(
    get_dataset(
        e_coli_regulondb,
        attributes = c("name", "strand", "posright", "product_name"),
        dataset = "GENE",
        filters = list(
            name = c("ARA"),
            product_name = c("Ara"),
            strand = c("forward"),
            posright = c("2000", "4000000")
        ),
        and = FALSE,
        partialmatch = c("name", "product_name"),
        interval = "posright"
    )
)

## ----'complex_filter_2'-------------------------------------------------------
nrow(
    get_dataset(
        e_coli_regulondb,
        attributes = c("name", "strand", "posright", "product_name"),
        dataset = "GENE",
        filters = list(
            name = c("ARA"),
            product_name = c("Ara"),
            strand = c("forward"),
            posright = c("2000", "4000000")
        ),
        and = TRUE,
        partialmatch = c("name", "product_name"),
        interval = "posright"
    )
)

## ----'gene_regulators', echo = TRUE-------------------------------------------
get_gene_regulators(e_coli_regulondb, c("araC", "fis", "crp"))

## ----'regulatory_network', echo = TRUE----------------------------------------
head(get_regulatory_network(e_coli_regulondb))

## ----'regulatory_summary'-----------------------------------------------------
get_regulatory_summary(e_coli_regulondb,
    gene_regulators = c("araC", "modB")
)

## ----'prep_cyto', eval=FALSE--------------------------------------------------
# get_regulatory_network(e_coli_regulondb, cytograph = TRUE)

## ----'binding_sites'----------------------------------------------------------
get_binding_sites(e_coli_regulondb, transcription_factor = "AraC")
get_binding_sites(e_coli_regulondb,
    transcription_factor = "AraC",
    output_format = "Biostrings"
)

## ----createVignette, eval=FALSE-----------------------------------------------
# ## Create the vignette
# library("rmarkdown")
# system.time(render("regutools.Rmd"))
# 
# ## Extract the R code
# library("knitr")
# knit("regutools.Rmd", tangle = TRUE)

## ----reproduce1, echo=FALSE---------------------------------------------------
## Date the vignette was generated
Sys.time()

## ----reproduce2, echo=FALSE---------------------------------------------------
## Processing time in seconds
totalTime <- diff(c(startTime, Sys.time()))
round(totalTime, digits = 3)

## ----reproduce3, echo=FALSE-------------------------------------------------------------------------------------------
## Session info
library("sessioninfo")
options(width = 120)
session_info()

## ----vignetteBiblio, results = 'asis', echo = FALSE, warning = FALSE, message = FALSE---------------------------------
## Print bibliography
PrintBibliography(bib, .opts = list(hyperlink = "to.doc", style = "html"))

#' @title Return complete regulatory network.
#' @description This function retrieves all the regulation networks in
#' regulonDB between TF-TF, GENE-GENE or TF-GENE depending on the parameter
#' 'type'.
#' @param regulondb A [regulondb()] object.
#' @param regulator Name of TF or gene that acts as regulator. If `NULL`, the
#' function retrieves all existent networks in the regulonDB.
#' @param type "TF-GENE", "TF-TF", "GENE-GENE"
#' @param cytograph If TRUE, displays network in Cytoscape. This option
#' requires previous instalation and launch of Cytoscape.
#'
#' @keywords regulation retrieval, TF, networks,
#' @author Carmina Barberena Jonas, Jesús Emiliano Sotelo Fonseca,
#' José Alquicira Hernández, Joselyn Chávez
#' @return A [regulondb_result][regutools::regulondb_result-class] object.
#' @examples
#'
#' ## Connect to the RegulonDB database if necessary
#' if (!exists("regulondb_conn")) regulondb_conn <- connect_database()
#'
#' ## Build the regulon db object
#' e_coli_regulondb <-
#'     regulondb(
#'         database_conn = regulondb_conn,
#'         organism = "E.coli",
#'         database_version = "1",
#'         genome_version = "1"
#'     )
#'
#' ## Retrieve regulation of 'araC'
#' get_regulatory_network(e_coli_regulondb,
#'     regulator = "AraC",
#'     type = "TF-GENE"
#' )
#'
#' ## Retrieve all GENE-GENE networks
#' get_regulatory_network(e_coli_regulondb, type = "GENE-GENE")
#'
#' ## Retrieve TF-GENE network of AraC and display in Cytoscape
#' ## Note that Cytospace needs to be open for this to work
#' cytoscape_present <- try(RCy3::cytoscapePing(), silent = TRUE)
#' if (!is(cytoscape_present, "try-error")) {
#'     get_regulatory_network(
#'         e_coli_regulondb,
#'         regulator = "AraC",
#'         type = "TF-GENE",
#'         cytograph = TRUE
#'     )
#' }
#' @export
#' @importFrom RCy3 cytoscapePing createNetworkFromDataFrames
#' setEdgeColorMapping setVisualStyle

get_regulatory_network <-
    function(regulondb,
    regulator = NULL,
    type = "TF-GENE",
    cytograph = FALSE) {
        # Check type parameter
        if (!type %in% c("GENE-GENE", "TF-GENE", "TF-TF")) {
            stop("Parameter 'type' must be TF-GENE, TF-TF, or GENE-GENE.",
                call. = FALSE
            )
        }

        # Get Network
        if (!is.null(regulator)) {
            network <-
                as.data.frame(get_dataset(
                    regulondb,
                    attributes = c(
                        "regulator_name", "regulated_name",
                        "effect"
                    ),
                    filters = list(
                        "network_type" = type,
                        "regulator_name" = regulator
                    ),
                    dataset = "NETWORK"
                ))
        } else {
            network <-
                as.data.frame(get_dataset(
                    regulondb,
                    attributes = c(
                        "regulator_name", "regulated_name",
                        "effect"
                    ),
                    filters = list("network_type" = type),
                    dataset = "NETWORK"
                ))
        }

        if (cytograph) {
            # CytoScape connection
            tryCatch(
                cytoscapePing(),
                error = function(e) {
                    stop(
                        paste(
                            "To use integration with Cytoscape,",
                            "please launch Cytoscape before running",
                            "get_regulatory_network()"
                        ),
                        call. = FALSE
                    )
                }
            )
            colnames(network) <-
                c("source", "target", "interaction")
            my_new_network <-
                createNetworkFromDataFrames(edges = network)
            # set visual parameters
            RCy3::setNodeShapeDefault(new.shape = "ELLIPSE")
            RCy3::setNodeSizeDefault(35)
            RCy3::setNodeColorDefault(new.color = "#ACE7F9")
            RCy3::setEdgeLabelMapping(table.column = "interaction")
            RCy3::setEdgeColorMapping(
                table.column = "interaction",
                table.column.values = c("activator", "repressor", "dual"),
                colors = c("#339900", "#CC3300", "#0033CC"),
                mapping.type = "d"
            )
        } else {
            colnames(network) <- c("regulator", "regulated", "effect")

            # Change effect to +, - and +/-
            network$effect <-
                sub(
                    pattern = "activator",
                    replacement = "+",
                    x = network$effect
                )
            network$effect <-
                sub(
                    pattern = "repressor",
                    replacement = "-",
                    x = network$effect
                )
            network$effect <-
                sub(
                    pattern = "dual",
                    replacement = "+/-",
                    x = network$effect
                )

            network <-
                dataframe_to_dbresult(network, regulondb, "NETWORK")

            return(network)
        }
    }

---
title: "regutools: an R package for the extraction of gene regulatory networks from RegulonDB"
author:
  - name: Joselyn Chávez
    affiliation:
    - &ibt Instituto de Biotecnología, Universidad Nacional Autónoma de México, Cuernavaca, Morelos, MX
    - &first Equal contribution
    email: joselynchavezf@gmail.com
  - name: Carmina Barberena Jonas
    affiliation:
    - &langebio LANGEBIO, Cinvestav, Irapuato, Guanajuato, MX
    - *first
    email: car.barjon@gmail.com
  - name: Jesus Emiliano Sotelo-Fonseca
    affiliation:
    - *langebio
    - *first
    email: jemiliano@gmail.com
  - name: Jose Alquicira Hernandez
    affiliation:
    - &ccg Centro de Ciencias Genómicas, Universidad Nacional Autónoma de México, Cuernavaca, Morelos, MX
    - University of Queensland, Brisbane, QLD, AU
  - name: Heladia Salgado
    affiliation:
    - *ccg
    email: heladia@ccg.unam.mx
  - name: Leonardo Collado-Torres
    affiliation:
    - &libd Lieber Institute for Brain Development, Johns Hopkins Medical Campus, Baltimore, MD, US
    - &ccb Center for Computational Biology, Johns Hopkins University, Baltimore, MD, US
    - &corres Co-corresponding author
    email: lcolladotor@gmail.com
  - name: Alejandro Reyes
    affiliation:
    - Dana Farber Cancer Institute, Boston, MA, US
    - *corres
    email: alejandro.reyes.ds@gmail.com
date: "`r BiocStyle::doc_date()`"
package: "`r BiocStyle::pkg_ver('regutools')`"
output: 
  BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{regutools: an R package for data extraction from RegulonDB}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>"
)
```

```{r vignetteSetup, echo=FALSE, message=FALSE, warning = FALSE}
## For links
library("BiocStyle")

## Track time spent on making the vignette
startTime <- Sys.time()

## Bib setup
library("RefManageR")

## Write bibliography information
bib <- c(
    R = citation(),
    AnnotationDbi = citation("AnnotationDbi"),
    AnnotationHub = citation("AnnotationHub"),
    BiocFileCache = citation("BiocFileCache"),
    BiocStyle = citation("BiocStyle"),
    Biostrings = citation("Biostrings"),
    DBI = citation("DBI"),
    GenomicRanges = citation("GenomicRanges"),
    Gviz = citation("Gviz"),
    IRanges = citation("IRanges"),
    knitr = citation("knitr")[3],
    RCy3 = citation("RCy3"),
    RefManageR = citation("RefManageR")[1],
    regutools = citation("regutools")[1],
    regutoolsPaper = citation("regutools")[2],
    rmarkdown = citation("rmarkdown")[1],
    RSQLite = citation("RSQLite"),
    S4Vectors = citation("S4Vectors"),
    sessioninfo = citation("sessioninfo"),
    testthat = citation("testthat")
)
```

# Basics

## Install `regutools`

`R` is an open-source statistical environment which can be easily modified to enhance its functionality via packages. `r Biocpkg('regutools')` is a `R` package available via Bioconductor. `R` can be installed on any operating system from [CRAN](https://cran.r-project.org/) after which you can install `r Biocpkg('regutools')` by using the following commands in your `R` session:

```{r 'install', eval = FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE)) {
      install.packages("BiocManager")
  }

BiocManager::install("regutools")

## Check that you have a valid Bioconductor installation
BiocManager::valid()
```

## Required knowledge

`r Biocpkg('regutools')` is based on many other packages and in particular in those that have implemented the infrastructure needed for dealing with genomic and sequence data. That is, packages like `r Biocpkg('Biostrings')` that allow you to work with sequences and `r Biocpkg('GenomicRanges')` for data on genomic coordinates. A `r Biocpkg('regutools')` user is not expected to deal with those packages directly but will need to be familiar with them to understand the results `r Biocpkg('regutools')` generates. Furthermore, it'll be useful for the user to know the syntax of `r Biocpkg('AnnotationHub')` `r Citep(bib[['AnnotationHub']])` in order to query and load the data provided by this package.

If you are asking yourself the question "Where do I start using Bioconductor?" you might be interested in [this blog post](http://lcolladotor.github.io/2014/10/16/startbioc/#.VkOKbq6rRuU).

## Asking for help

As package developers, we try to explain clearly how to use our packages and in which order to use the functions. But `R` and `Bioconductor` have a steep learning curve so it is critical to learn where to ask for help. The blog post quoted above mentions some but we would like to highlight the [Bioconductor support site](https://support.bioconductor.org/) as the main resource for getting help regarding Bioconductor. Other alternatives are available such as creating GitHub issues and tweeting. However, please note that if you want to receive help you should adhere to the [posting guidelines](http://www.bioconductor.org/help/support/posting-guide/). It is particularly critical that you provide a small reproducible example and your session information so package developers can track down the source of the error.

## Citing `regutools`

We hope that `r Biocpkg('regutools')` will be useful for your research. Please use the following information to cite the package and the overall approach. Thank you!

```{r 'citation'}
## Citation info
citation("regutools")
```

# Overview

*Escherichia coli K-12 (E. coli)* is the best bacterial organism studied to date. Thousands of papers have been published using *E. coli* as a model system asking how genes are regulated. The throughput of these experiments range from single-gene studies to whole-genome approaches. Twenty years ago, the database [*RegulonDB*](http://regulondb.ccg.unam.mx/) started collecting, curating and organizing this information into a centralized resource. Thanks to this huge efforts, researchers have had an easy way to access all these data in a database, facilitating the advancements of complete fields, such as *systems biology*. 

The analysis of high-throughput experiments -such as RNA-seq or ChIP-seq- often requires the integration of databases such as *RegulonDB* in order to give biological interpretations to these data. The *regutools* package is designed to facilitate such integration by providing programmatic access to *RegulonDB* within the R environment `r Citep(bib[['regutoolsPaper']])`. The package retrieves information from the *RegulonDB* database into *Bioconductor* objects, ready for downstream analyses. 

The package defines the object **regulondb**, which is a data structure that contains the path to a *SQLite* database retrieved from *RegulonDB* along with metadata such as database version and reference genome. The function `connect_database()` will retrieve the latest version of the database and connect to it. It will download the database using `r Biocpkg('AnnotationHub')` or a backup mechanism if necessary. The *regutools* package contains functions with the most popular queries to *regutools*, such as retrieving information of which gene targets are regulated by a transcription factor. But users can also design queries that are specific to their analyses. This vignette describes how to use the provided functions and how to design programmatic queries to *regutools*. The general syntax of the function calls of this package is `result <- functionCalled( regulondb, arguments )`. 

# The **regulondb** object

The **regulondb** object is an extension of an **SQLiteConnection** class that host a connection to a database with the table structure defined in the *RegulonDB* database. It contains additional slots that specify the organism, genome version and database version. The function `regulondb()` is the constructor function of **regulondb** objects. This function receives as input a file path to the database file as well as information about the annotation as character vectors.

```{r 'connect_db', echo = TRUE, message=FALSE}
library("regutools")

## Other packages used
library("Biostrings")

## Connect to the RegulonDB database
regulondb_conn <- connect_database()

## Build a regulondb object
e_coli_regulondb <-
    regulondb(
        database_conn = regulondb_conn,
        organism = "E.coli",
        database_version = "1",
        genome_version = "1"
    )

e_coli_regulondb
```

In order to get an overview of the tables present in a *regulondb* object, we can use the function `list_datasets()`. This function will output all the available tables (datasets) that can be used to build queries. 

```{r 'list_datasets', echo = TRUE}
list_datasets(e_coli_regulondb)
```

For each table in the database, users can explore the fields (or attributes) of each table using the function `list_attributes`.

```{r 'list_attr'}
head(list_attributes(e_coli_regulondb, "GENE"), 8)
```

# Retrieving data

Since the *regulondb* object is an extension of the *SQLiteConnection*, users can retrieve data from a *regulondb* object using the function `dbGetQuery()`. Additionally, this package provides a wrapper function to build queries to the database. This function is called `get_dataset()` and has a very similar syntax to the `getBM()` function from the biomaRt package. The main arguments of the `get_dataset()` function are a *regulondb* object, a dataset (or table) of the database, the fields of the dataset to retrieve (attributes) and filters to specify what information to get. The code below shows an example where three attributes from the dataset **"GENE"** for the genes *araC*, *crp* and *lacI*. Note that if the `filters=` parameter is empty, the function will retrieve all the hits it find in the database.  

```{r 'get_dataset', echo = TRUE}
get_dataset(
    regulondb = e_coli_regulondb,
    dataset = "GENE",
    attributes = c("posleft", "posright", "strand", "name"),
    filters = list("name" = c("araC", "crp", "lacI"))
)
```

Some of the filters, such as *posright* or *posleft*, can be filtered by specifying intervals. For example, the code below indicates that all the start positions *posright" should be between position 1 and position 5000 of the genome. The parameter `inverval=` is used to specify that the filter for that field will be defined by an interval rather than a exact match.

```{r 'get_dataset_interval', echo = TRUE}
get_dataset(
    e_coli_regulondb,
    attributes = c("posright", "name"),
    filters = list("posright" = c(1, 5000)),
    interval = "posright",
    dataset = "GENE"
)
```

# The **regulondb_result** object and integration into the *BioC* ecosystem

By default, the function `get_dataset()` outputs a **regulondb_result** object, which is an extension of a **DataFrame** that stores information about the query used to generate this object. This additional information includes the organism name, the database and genome versions, and the table (or dataset) of the *regulondb* object that was queried by `get_dataset()`.

```{r 'get_dataset_DF'}
res <- get_dataset(
    regulondb = e_coli_regulondb,
    dataset = "GENE",
    attributes = c("posleft", "posright", "strand", "name"),
    filters = list("name" = c("araC", "crp", "lacI"))
)
slotNames(res)
```

To enable integration with other Bioconductor packages, we provide the function `convert_to_granges()` which converts a **regulondb_result** object into a **GRanges** object whenever possible. For example, the result stored in the variable `res` has genomic coordinates and it is thus possible convert `res` into a **GRanges** object. 

```{r 'convert_granges'}
convert_to_granges(res)
```

An alternative way to get to the same result is to use the parameter `output_format=` directly in the function `get_dataset()`. 

```{r 'get_dataset_GRanges'}
get_dataset(
    regulondb = e_coli_regulondb,
    dataset = "GENE",
    attributes = c("posleft", "posright", "strand", "name"),
    filters = list("name" = c("araC", "crp", "lacI")),
    output_format = "GRanges"
)
```

In a similar manner, the function `convert_to_biostrings()` converts **regulondb** objects into objects from the `r BiocStyle::Biocpkg("Biostrings")` package. Possible outputs of `convert_to_biostrings()` are **DNAStringSet** objects if `seq_type="DNA"` or a **BStringSet** if `seq_type="product"`. 

```{r 'dnastring_res'}
res_dnastring <- get_dataset(
    regulondb = e_coli_regulondb,
    dataset = "GENE",
    attributes = c("posleft", "posright", "strand", "name", "dna_sequence"),
    filters = list("name" = c("araC", "crp", "lacI"))
)
res_dnastring <-
    convert_to_biostrings(res_dnastring, seq_type = "DNA")
res_dnastring
GenomicRanges::mcols(res_dnastring)
```

```{r 'product_seq'}
res_prodstring <- get_dataset(
    regulondb = e_coli_regulondb,
    dataset = "GENE",
    attributes = c("posleft", "posright", "strand", "name", "product_sequence"),
    filters = list("name" = c("araC", "crp", "lacI"))
)
res_prodstring <-
    convert_to_biostrings(res_prodstring, seq_type = "product")
mcols(res_prodstring)
```

As with the **GRanges** output mentioned above, it is possible for the output of `get_dataset()` to be a **DNAStringSet** object by specifying the parameter `output_format="DNAStringSet"` or a **BStringSet** object by specifying `output_format="BStringSet"`. Note that the functions to convert **regulondb_result** objects will throw errors if there is insufficient information for the coercion to occur. For example, we will get an error if we try to convert into a **GRanges** object when genomic coordinates are missing from the **regulondb_result** object.

# Building your own queries

In the *regutools* package, we have implemented features that are commonly used when querying data from databases: filtering results by partial matching, filtering by numeric intervals, and building complex queries.

## Partial matching

The code below illustrates the concept of partial matching, in which by setting the parameter `partialmatch=` to `"name"`, the query returns all the gene name in which the word *ara* is contained. 

```{r 'partial_match', echo = TRUE}
get_dataset(
    e_coli_regulondb,
    attributes = c("posright", "name"),
    filters = list("name" = "ara"),
    partialmatch = "name",
    dataset = "GENE"
)
```

Note that setting the parameter `partialmatch=` to `NULL` will only return genes where the name string is identical to *ara*. 

## Filtering by numeric intervals

In addition to partial matching, queries can be filtered by numeric intervals. For example, in the code below, the parameter `interv=` is set to `"posright"`. By doing this assignment, we are specifying that the values for `"posright"` must lie between the values of `posright` specified in the `filter=` parameter. Thus, the result of this query will be genes whose right positions lie between the coordinates 2000 and 4000000. Note that the use of the `interv=` parameter in the code below is equivalent to setting the parameter `output_format=` to `"GRanges"` and further subsetting the *GRanges* object using the function `subsetByOverlaps()`. 

```{r 'position_interval', echo = TRUE}
get_dataset(
    e_coli_regulondb,
    attributes = c("name", "strand", "posright", "product_name"),
    dataset = "GENE",
    filters = list(posright = c("2000", "4000000")),
    interval = "posright"
)
```

## Retrieving genomic elements

Based on genomic coordinates, the code below retrieves all genomic elements whose positions lie between the coordinates provided as a *GRanges* object. If no aditional parameters are provided, the result will retrieve genes that relies within the first 5000pb from the E. coli genome. 

```{r 'genomic_elements', echo = TRUE }
get_dna_objects(e_coli_regulondb)
```

Especific genomic positions can be provided within the parameter `grange`. It is important to provide a genomic range that covers as minimal the length of one genomic element.

```{r 'especific_ranges', echo = TRUE }
grange <- GenomicRanges::GRanges(
    "chr",
    IRanges::IRanges(5000, 10000)
)
get_dna_objects(e_coli_regulondb, grange)
```

Aditional genomic elements such as "-35 promoter box", "gene", "promoter", "Regulatory Interaction", "sRNA interaction", or "terminator" can be selected.

```{r 'aditional_elements', echo = TRUE}
grange <- GenomicRanges::GRanges(
    "chr",
    IRanges::IRanges(5000, 10000)
)
get_dna_objects(e_coli_regulondb, grange, elements = c("gene", "promoter"))
```

Evenmore, the genomic elements retrieved can be observed in a Genome Browser-like plot. The genomic elements are annotated using a UCSC genome as reference, it is important to provide a valid chromosome name for annotation purpose.

```{r 'plot_elements', echo = TRUE}
e_coli_regulondb <-
    regulondb(
        database_conn = regulondb_conn,
        organism = "chr",
        database_version = "1",
        genome_version = "1"
    )

grange <- GenomicRanges::GRanges("chr", IRanges::IRanges(5000, 10000))
plot_dna_objects(e_coli_regulondb, grange, elements = c("gene", "promoter"))
```

## Complex filters

The examples so far have considered queries in which the results are filtered according to single fields from tables. In order to build queries with filters from more than one field, several filters names can be passed as a list to the `filters=` argument. Additionally the `and=` argument is used to specify whether the filtering conditions of the result of the query must be satisfied (`and=TRUE`) or if satisfying a single condition is enough (`and=FALSE`). 

For example, the code below extracts the genes where either `name` or `product_name` contain the word *Ara* or *Ara*, respectively, if the gene is in the forward strand or if the right position of the gene is between 2000 and 40000000. 

```{r 'complex_filter'}
nrow(
    get_dataset(
        e_coli_regulondb,
        attributes = c("name", "strand", "posright", "product_name"),
        dataset = "GENE",
        filters = list(
            name = c("ARA"),
            product_name = c("Ara"),
            strand = c("forward"),
            posright = c("2000", "4000000")
        ),
        and = FALSE,
        partialmatch = c("name", "product_name"),
        interval = "posright"
    )
)
```

The query below, which is identical to the query above except the `and=` is set to `TRUE`, returns the genes where all of the specified conditions are satisfied. 

```{r 'complex_filter_2'}
nrow(
    get_dataset(
        e_coli_regulondb,
        attributes = c("name", "strand", "posright", "product_name"),
        dataset = "GENE",
        filters = list(
            name = c("ARA"),
            product_name = c("Ara"),
            strand = c("forward"),
            posright = c("2000", "4000000")
        ),
        and = TRUE,
        partialmatch = c("name", "product_name"),
        interval = "posright"
    )
)
```

# Functions with implement popular queries

The regutools package provides functions that encode the most frequent queries that are submitted to the *RegulonDB* web resource.

## Extracting regulatory networks

One of the most important information that the *RegulonDB* database contains are manually curated regulatory networks. The *regutools* package exports the function `get_gene_regulators()`, which inputs a vector of gene names and outputs information about what are the transcription factors that regulate such genes together with the regulatory effect (activator, repressor or dual).

```{r 'gene_regulators', echo = TRUE}
get_gene_regulators(e_coli_regulondb, c("araC", "fis", "crp"))
```

Similarly, the `get_regulatory_network()` function retrieves all the regulatory network from a **regulondb** object. By default, the output will be a list of transcription factor-gene pairs, indicating which transcription factor regulates which gene.

```{r 'regulatory_network', echo = TRUE}
head(get_regulatory_network(e_coli_regulondb))
```

But users can also set the parameter `type=` to `"GENE-GENE"` or `"TF-GENE"` to retrieve gene-gene regulatory networks or transcription factor-transcription factor regulatory networks, respectively. 

Users can also use the `get_regulatory_summary()` to retrieve a summary of the transcription factor regulated the expression of a set of given genes. The parameter `gene_regulators` can receive either a vector of gene names or the output of a call to the function `get_gene_regulators()`. The resulting output is a *regulondb_result* object in which each row shows a transcription factor, and the columns display information about the number, percentage and regulatory activity exerted to the genes.

```{r 'regulatory_summary'}
get_regulatory_summary(e_coli_regulondb,
    gene_regulators = c("araC", "modB")
)
```

## Visualizing networks using cytoscape

Software tools such as [Cytoscape](https://cytoscape.org/index.html) are often useful for interactive exploration of data and visualization of networks. The function `get_regulatory_network()` has a parameter `cytograph=` that if set to `TRUE`, it will visualize the network in a cytoscape session. Of note, this feature will only work if the user has Cytoscape open in their computer. 

```{r 'prep_cyto', eval=FALSE}
get_regulatory_network(e_coli_regulondb, cytograph = TRUE)
```

## Transcription factor binding sites

Another common request to the *RegulonDB* database is to obtain the genomic coordinates and sequences of the DNA binding sites for a given transcription factor. This query is implemented in the function `get_binding_sites()`, in which the results are formatted according to the parameter `output_format=` as either a *GRanges* object or a *Biostrings* object. 

```{r 'binding_sites'}
get_binding_sites(e_coli_regulondb, transcription_factor = "AraC")
get_binding_sites(e_coli_regulondb,
    transcription_factor = "AraC",
    output_format = "Biostrings"
)
```

# A note about CDSB

This was a project accomplished by members of the [Community of Bioinformatics Software Developers](https://comunidadbioinfo.github.io/) (CDSB in Spanish). In part CDSB was formed to help R users in Latin America become R/[Bioconductor](http://bioconductor.org/) developers. For more information about CDSB, the CDSB workshops or its online community, please check the [CDSB website](https://comunidadbioinfo.github.io/) which is available in both Spanish and English.

<a href="https://comunidadbioinfo.github.io/"><img src="https://comunidadbioinfo.github.io/img/Logo_texto-768x107.png"></a>

# Reproducibility

The `r Biocpkg('regutools')` package `r Citep(bib[['regutools']])` was made possible thanks to:

* R `r Citep(bib[['R']])`
* `r Biocpkg('AnnotationDbi')` `r Citep(bib[['AnnotationDbi']])`
* `r Biocpkg('AnnotationHub')` `r Citep(bib[['AnnotationHub']])`
* `r Biocpkg('BiocFileCache')` `r Citep(bib[['BiocFileCache']])`
* `r Biocpkg('BiocStyle')` `r Citep(bib[['BiocStyle']])`
* `r Biocpkg('Biostrings')` `r Citep(bib[['Biostrings']])`
* `r CRANpkg('DBI')` `r Citep(bib[['DBI']])`
* `r Biocpkg('GenomicRanges')` `r Citep(bib[['GenomicRanges']])`
* `r Biocpkg('Gviz')` `r Citep(bib[['Gviz']])`
* `r Biocpkg('IRanges')` `r Citep(bib[['IRanges']])`
* `r CRANpkg('knitr')` `r Citep(bib[['knitr']])`
* `r Biocpkg('RCy3')` `r Citep(bib[['RCy3']])`
* `r CRANpkg("RefManageR")` `r Citep(bib[["RefManageR"]])`
* `r CRANpkg('rmarkdown')` `r Citep(bib[['rmarkdown']])`
* `r CRANpkg('RSQLite')` `r Citep(bib[['RSQLite']])`
* `r Biocpkg('S4Vectors')` `r Citep(bib[['S4Vectors']])`
* `r CRANpkg('sessioninfo')` `r Citep(bib[['sessioninfo']])`
* `r CRANpkg('testthat')` `r Citep(bib[['testthat']])`

Code for creating the vignette

```{r createVignette, eval=FALSE}
## Create the vignette
library("rmarkdown")
system.time(render("regutools.Rmd"))

## Extract the R code
library("knitr")
knit("regutools.Rmd", tangle = TRUE)
```


Date the vignette was generated.

```{r reproduce1, echo=FALSE}
## Date the vignette was generated
Sys.time()
```

Wallclock time spent generating the vignette.

```{r reproduce2, echo=FALSE}
## Processing time in seconds
totalTime <- diff(c(startTime, Sys.time()))
round(totalTime, digits = 3)
```

`R` session information.

```{r reproduce3, echo=FALSE}
## Session info
library("sessioninfo")
options(width = 120)
session_info()
```

# Bibliography

This vignette was generated using `r Biocpkg('BiocStyle')` `r Citep(bib[['BiocStyle']])`, `r CRANpkg('knitr')` `r Citep(bib[['knitr']])` and `r CRANpkg('rmarkdown')` `r Citep(bib[['rmarkdown']])` running behind the scenes.

Citations made with `r CRANpkg('RefManageR')` `r Citep(bib[['RefManageR']])`.

```{r vignetteBiblio, results = 'asis', echo = FALSE, warning = FALSE, message = FALSE}
## Print bibliography
PrintBibliography(bib, .opts = list(hyperlink = "to.doc", style = "html"))
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_dataset.R
\name{get_dataset}
\alias{get_dataset}
\title{Extract data from RegulonDB}
\usage{
get_dataset(
  regulondb,
  dataset = NULL,
  attributes = NULL,
  filters = NULL,
  and = TRUE,
  interval = NULL,
  partialmatch = NULL,
  output_format = "regulondb_result"
)
}
\arguments{
\item{regulondb}{A \code{\link[=regulondb]{regulondb()}} object.}

\item{dataset}{Dataset of interest. Use the function list_datasets for an
overview of valid datasets.}

\item{attributes}{Vector of attributes to be retrieved.}

\item{filters}{List of filters to be used. The names should correspond to
the attribute and the values correspond to the condition for selection.}

\item{and}{Logical argument. If FALSE, filters will be considered under the
"OR" operator}

\item{interval}{the filters whose values will be considered as interval}

\item{partialmatch}{name of the condition(s) with a string pattern for full
or partial match in the query}

\item{output_format}{A string specifying the output format. Possible options
are "regulondb_result", "GRanges", "DNAStringSet" or "BStringSet".}
}
\value{
By default, a regulon_results object. If specified in the parameter
output_format, it can also return either a GRanges object or a Biostrings
object.
}
\description{
This function retrieves data from RegulonDB. Attributes from
datasets can be selected and filtered.
}
\examples{
## Connect to the RegulonDB database if necessary
if (!exists("regulondb_conn")) regulondb_conn <- connect_database()

## Build the regulon db object
e_coli_regulondb <-
    regulondb(
        database_conn = regulondb_conn,
        organism = "E.coli",
        database_version = "1",
        genome_version = "1"
    )

## Obtain all the information from the "GENE" dataset
get_dataset(e_coli_regulondb, dataset = "GENE")

## Get the attributes posright and name from the "GENE" dataset
get_dataset(e_coli_regulondb,
    dataset = "GENE",
    attributes = c("posright", "name")
)

## From "GENE" dataset, get the gene name, strand, posright, product name
## and id of all genes regulated with name like "ara", strand as "forward"
## with a position right between 2000 and 40000
get_dataset(
    e_coli_regulondb,
    dataset = "GENE",
    attributes = c("name", "strand", "posright", "product_name", "id"),
    filters = list(
        name = c("ara"),
        strand = c("forward"),
        posright = c("2000", "40000")
    ),
    and = TRUE,
    partialmatch = "name",
    interval = "posright"
)
}
\author{
Carmina Barberena Jonas, Jesús Emiliano Sotelo Fonseca,
José Alquicira Hernández, Joselyn Chávez
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_dna_objects.R
\name{get_dna_objects}
\alias{get_dna_objects}
\title{Retrieve genomic elements from regulonDB}
\usage{
get_dna_objects(
  regulondb,
  genome = "eschColi_K12",
  grange = GRanges("chr", IRanges(1, 5000)),
  elements = "gene"
)
}
\arguments{
\item{regulondb}{A \code{\link[=regulondb]{regulondb()}} object.}

\item{genome}{A valid UCSC genome name.}

\item{grange}{A \code{\link[GenomicRanges:GRanges-class]{GenomicRanges::GRanges-class()}} object indicating position
left and right.}

\item{elements}{A character vector specifying which annotation elements to
plot. It can be any from: \code{"-10 promoter box"}, \code{"-35 promoter box"},
\code{"gene"}, \code{"promoter"}, \code{"Regulatory Interaction"}, \code{"sRNA interaction"},
or \code{"terminator"}.}
}
\value{
\code{\link[GenomicRanges:GRanges-class]{GenomicRanges::GRanges-class()}} object with the elements found.
}
\description{
Retrieve genomic elements from regulonDB
}
\examples{
## Connect to the RegulonDB database if necessary
if (!exists("regulondb_conn")) {
      regulondb_conn <- connect_database()
  }

## Build the regulondb object
e_coli_regulondb <-
    regulondb(
        database_conn = regulondb_conn,
        organism = "chr",
        database_version = "1",
        genome_version = "1"
    )

## Get all genes from E. coli
get_dna_objects(e_coli_regulondb)

## Get genes providing Genomic Ranges
grange <- GenomicRanges::GRanges(
    "chr",
    IRanges::IRanges(5000, 10000)
)
get_dna_objects(e_coli_regulondb, grange)

## Get aditional elements within genomic positions
get_dna_objects(e_coli_regulondb,
    grange,
    elements = c("gene", "promoter")
)
}
\author{
Joselyn Chavez
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_gene_synonyms.R
\name{get_gene_synonyms}
\alias{get_gene_synonyms}
\title{Retrieve gene synonyms}
\usage{
get_gene_synonyms(
  regulondb,
  genes,
  from = "name",
  to = c("id", "name", "bnumber", "gi")
)
}
\arguments{
\item{regulondb}{A \code{\link[=regulondb]{regulondb()}} object.}

\item{genes}{Character vector of gene identifiers (id, name, bnumber or gi).}

\item{from}{A \code{character()} specifying one of: id, name, bnumber of gi}

\item{to}{A \code{character()} specifying one or more of: id, name, bnumber of gi}
}
\value{
A \link[=regulondb_result-class]{regulondb_result} object.
}
\description{
Given a list of genes (id, name, bnumber or gi),
get the gene synonyms (name, bnumber of gi).
}
\examples{
## Connect to the RegulonDB database if necessary
if (!exists("regulondb_conn")) regulondb_conn <- connect_database()

## Build the regulon db object
e_coli_regulondb <-
    regulondb(
        database_conn = regulondb_conn,
        organism = "E.coli",
        database_version = "1",
        genome_version = "1"
    )

## Lists all available identifiers for "araC"
get_gene_synonyms(e_coli_regulondb, "araC", from = "name")

## Retrieve only the ID
get_gene_synonyms(e_coli_regulondb, "araC", from = "name", to = "id")

## Use an ID to retrieve the synonyms
get_gene_synonyms(e_coli_regulondb, "ECK120000998", from = "id")
}
\author{
Jesús Emiliano Sotelo Fonseca
}
\keyword{bnumber,}
\keyword{geneid,}
\keyword{gi,}
\keyword{synonyms}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/list_datasets.R
\name{list_datasets}
\alias{list_datasets}
\title{List available datasets in RegulonDB database}
\usage{
list_datasets(regulondb)
}
\arguments{
\item{regulondb}{A regulondb class.}
}
\value{
A \code{character()} with the names of the available datasets.
}
\description{
This function returns a vector of all available tables from a
regulondb class.
}
\examples{

## Connect to the RegulonDB database if necessary
if (!exists("regulondb_conn")) regulondb_conn <- connect_database()

## Build the regulon db object
e_coli_regulondb <-
    regulondb(
        database_conn = regulondb_conn,
        organism = "E.coli",
        database_version = "1",
        genome_version = "1"
    )

## List the available datasets
list_datasets(e_coli_regulondb)
}
\keyword{data}
\keyword{database}
\keyword{datasets}
\keyword{retrieval}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/existing_partial_match.R
\name{existing_partial_match}
\alias{existing_partial_match}
\title{Constructs a logical condition to query database}
\usage{
existing_partial_match(filters, partialmatch, operator)
}
\arguments{
\item{filters}{List of filters to be used. The names should correspond to
the attribute and the values correspond to the condition for selection.}

\item{partialmatch}{name of the condition(s) with a string pattern for full
or partial match in the query.}

\item{operator}{A string indicating if all the filters (AND) or some of them
(OR) should be met.}
}
\value{
A \code{character(1)} with the sql logical condition to query the dataset.
}
\description{
Given a list of filters, this function builds a logical
condition to query database using intervals.
The output is used in \code{\link[=existing_intervals]{existing_intervals()}} and \code{\link[=non_existing_intervals]{non_existing_intervals()}}.
}
\examples{

## Build the SQL query for existing partial matches for ara
existing_partial_match(
    filters = list(
        name = c("ara"),
        strand = c("forward"),
        posright = c("2000", "40000")
    ),
    partialmatch = "name",
    operator = "AND"
)
}
\author{
Carmina Barberena Jonás, Jesús Emiliano Sotelo Fonseca,
José Alquicira Hernández
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regulondb-classes.R
\docType{class}
\name{regulondb_result-class}
\alias{regulondb_result-class}
\title{The regulondb_results class}
\description{
The regulondb class is an extension of the DataFrame class,
with
additional slots that host information of the database used to obtain these
results.
}
\section{Slots}{

\describe{
\item{\code{organism}}{A character string with the name of the organism of the
database.}

\item{\code{genome_version}}{A character string with the version of the genome
build.}

\item{\code{database_version}}{A character string with the version of regulondb
build.}

\item{\code{dataset}}{A character string with the name of the table used for the
query in get_dataset().}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_binding_sites.R
\name{get_binding_sites}
\alias{get_binding_sites}
\title{Get the binding sites for a Transcription Factor (TF)}
\usage{
get_binding_sites(regulondb, transcription_factor, output_format = "GRanges")
}
\arguments{
\item{regulondb}{A \code{\link[=regulondb]{regulondb()}} object.}

\item{transcription_factor}{name of the transcription factor.}

\item{output_format}{The output object. Can be either a \code{GRanges} (default)
or \code{Biostrings}.}
}
\value{
Either a GRanges object or a Biostrings object summarizing
information
about the binding sites of the transcription factors.
}
\description{
Retrieve the binding sites and genome location for a given
transcription factor.
}
\examples{
## Connect to the RegulonDB database if necessary
if (!exists("regulondb_conn")) regulondb_conn <- connect_database()

## Build the regulon db object
e_coli_regulondb <-
    regulondb(
        database_conn = regulondb_conn,
        organism = "E.coli",
        database_version = "1",
        genome_version = "1"
    )

## Get the binding sites for AraC
get_binding_sites(e_coli_regulondb, transcription_factor = "AraC")
}
\author{
José Alquicira Hernández, Jacques van Helden, Joselyn Chávez
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regulondb-classes.R
\docType{class}
\name{regulondb-class}
\alias{regulondb-class}
\title{The regulondb class}
\description{
The regulondb class is an extension of the SQLiteConnection,
which as the name suggests, consists of an SQLite connection to a database
with the table design of the
RegulonDb database. In addition to the slots defined in the
SQLiteConnection object,
the regulondb class also contains additional slots to store
information about database versions, organism information and genome build
versions.
}
\section{Slots}{

\describe{
\item{\code{organism}}{A character vector with the name of the organism of the
database.}

\item{\code{genome_version}}{A character vector with the version of the genome
build.}

\item{\code{database_version}}{A character vector with the version of regulondb
build.}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/build_condition.R
\name{build_condition}
\alias{build_condition}
\title{Construct logical condition to query database}
\usage{
build_condition(regulondb, dataset, filters, operator, interval, partialmatch)
}
\arguments{
\item{regulondb}{A \code{\link[=regulondb]{regulondb()}} object.}

\item{dataset}{dataset of interest}

\item{filters}{List of filters to be used. The names should correspond to
the attribute and the values correspond to the condition for selection.}

\item{operator}{A string indicating if all the filters (AND) or some of them
(OR) should be met}

\item{interval}{the filters with values considered as interval}

\item{partialmatch}{name of the condition(s) with a string pattern for full
or partial match in the query}
}
\value{
A \code{character(1)} with the sql logical condition to query the dataset
.
}
\description{
Given a list of filters, this function builds a logical
condition to query database.
The output is used in \code{\link[=get_dataset]{get_dataset()}}.
}
\examples{

## Connect to the RegulonDB database if necessary
if (!exists("regulondb_conn")) regulondb_conn <- connect_database()

## Build the regulon db object
e_coli_regulondb <-
    regulondb(
        database_conn = regulondb_conn,
        organism = "E.coli",
        database_version = "1",
        genome_version = "1"
    )

## Build the condition for ara
build_condition(
    e_coli_regulondb,
    dataset = "GENE",
    filters = list(
        name = c("ara"),
        strand = c("forward"),
        posright = c("2000", "40000")
    ),
    operator = "AND",
    interval = "posright",
    partialmatch = "name"
)
}
\author{
Carmina Barberena Jonás, Jesús Emiliano Sotelo Fonseca,
José Alquicira Hernández, Joselyn Chávez
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_gene_regulators.R
\name{get_gene_regulators}
\alias{get_gene_regulators}
\title{Get TFs or genes that regulate the genes of interest}
\usage{
get_gene_regulators(regulondb, genes, format = "multirow", output.type = "TF")
}
\arguments{
\item{regulondb}{A regulondb class.}

\item{genes}{Vector of genes (name, bnumber or GI).}

\item{format}{Output format: multirow, onerow, table}

\item{output.type}{How regulators will be represented: "TF"/"GENE"}
}
\value{
A \link[=regulondb_result-class]{regulondb_result} object.
}
\description{
Given a list of genes (name, bnumber or GI),
get all transcription factors or genes that regulate them.
The effect of regulators over the gene of interest can be positive (+),
negative (-) or dual (+/-)
}
\examples{
## Connect to the RegulonDB database if necessary
if (!exists("regulondb_conn")) regulondb_conn <- connect_database()

## Build the regulon db object
e_coli_regulondb <-
    regulondb(
        database_conn = regulondb_conn,
        organism = "E.coli",
        database_version = "1",
        genome_version = "1"
    )

## Get Transcription factors that regulate araC in one row
get_gene_regulators(
    e_coli_regulondb,
    genes = c("araC"),
    output.type = "TF",
    format = "onerow"
)

## Get genes that regulate araC in table format
get_gene_regulators(
    e_coli_regulondb,
    genes = c("araC"),
    output.type = "GENE",
    format = "table"
)
}
\author{
Carmina Barberena Jonas, Jesús Emiliano Sotelo Fonseca,
José Alquicira Hernández, Joselyn Chávez
}
\keyword{TFs,}
\keyword{networks,}
\keyword{regulation}
\keyword{retrieval,}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regulondb-methods.R
\docType{methods}
\name{show}
\alias{show}
\alias{show,regulondb-method}
\title{Methods for regulondb objects}
\usage{
\S4method{show}{regulondb}(object)
}
\arguments{
\item{object}{A regulondb object}
}
\value{
A \link[=regulondb]{regulondb} object.
}
\description{
Methods for regulondb objects
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regulondb-classes.R
\name{regulondb}
\alias{regulondb}
\alias{build_regulondb}
\title{Constructor function of a regulondb class}
\usage{
regulondb(database_conn, organism, genome_version, database_version)
}
\arguments{
\item{database_conn}{A
\link[RSQLite:SQLiteConnection-class]{SQLiteConnection-class} connection to
the RegulonDB database made with \code{\link[=connect_database]{connect_database()}}.}

\item{organism}{A character vector with the name of the organism of the
database.}

\item{genome_version}{A character vector with the version of the genome
build.}

\item{database_version}{A character vector with the version of regulondb
build.}
}
\value{
A \link[=regulondb]{regulondb} object.
}
\description{
The build_regulondb function is a constructor function of a
regulondb class.
}
\examples{

## Connect to the RegulonDB database if necessary
if (!exists("regulondb_conn")) regulondb_conn <- connect_database()

## Build a regulondb object
e_coli_regulondb <-
    regulondb(
        database_conn = regulondb_conn,
        organism = "E.coli",
        database_version = "1",
        genome_version = "1"
    )
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/connect_database.R
\name{connect_database}
\alias{connect_database}
\title{Connect to the regulondb database}
\usage{
connect_database(
  ah = AnnotationHub::AnnotationHub(),
  bfc = BiocFileCache::BiocFileCache()
)
}
\arguments{
\item{ah}{An \code{AnnotationHub} object
\link[AnnotationHub:AnnotationHub-class]{AnnotationHub-class}. Can be \code{NULL}
if you want to force to use the backup download mechanism.}

\item{bfc}{A \code{BiocFileCache} object
\link[BiocFileCache:BiocFileCache-class]{BiocFileCache-class}. Used when
\code{ah} is not available.}
}
\value{
An \link[RSQLite:SQLiteConnection-class]{SQLiteConnection-class}
connection to the RegulonDB database.
}
\description{
This function downloads the RegulonDB SQLite database file
prior to making a connection to it. It will cache the database file such
that subsequent calls will run faster. This function requires an active
internet connection.
}
\examples{

## Connect to the RegulonDB database if necessary
if (!exists("regulondb_conn")) regulondb_conn <- connect_database()

## Connect to the database without using AnnotationHub
regulondb_conn_noAH <- connect_database(ah = NULL)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_dataset.R
\name{convert_to_biostrings}
\alias{convert_to_biostrings}
\title{Function to convert output of regulondb queries to Biostrings objects}
\usage{
convert_to_biostrings(regulondb_result, seq_type = "DNA")
}
\arguments{
\item{regulondb_result}{A regulon_result object.}

\item{seq_type}{A character string with either DNA or protein, specyfing what}
}
\value{
A \link[Biostrings:XStringSet-class]{XStringSet} object.
}
\description{
This function converts, when possible, a regulon_result object into a Biostrings object.
}
\examples{
## Connect to the RegulonDB database if necessary
if (!exists("regulondb_conn")) regulondb_conn <- connect_database()

## Build the regulon db object
e_coli_regulondb <-
    regulondb(
        database_conn = regulondb_conn,
        organism = "E.coli",
        database_version = "1",
        genome_version = "1"
    )

## Obtain all the information from the "GENE" dataset
convert_to_biostrings(get_dataset(e_coli_regulondb, dataset = "GENE"))
}
\author{
Alejandro Reyes
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_summary.R
\name{get_regulatory_summary}
\alias{get_regulatory_summary}
\title{Return summary of gene regulation.}
\usage{
get_regulatory_summary(regulondb, gene_regulators)
}
\arguments{
\item{regulondb}{A \code{\link[=regulondb]{regulondb()}} object.}

\item{gene_regulators}{Result from \code{\link[=get_gene_regulators]{get_gene_regulators()}} or vector of
genes}
}
\value{
A data frame with the following columns:
\itemize{
\item The name or gene of TF
\item Regulated Genes per TF
\item Percent of regulated genes per TF
\item positive, negative or dual regulation
\item Name(s) of regulated genes
}
}
\description{
This function takes the output of \code{\link[=get_gene_regulators]{get_gene_regulators()}} with
format multirow,
onerow or table, or a vector with genes and retrieves information about the
TFs and their regulated genes
}
\examples{
## Connect to the RegulonDB database if necessary
if (!exists("regulondb_conn")) regulondb_conn <- connect_database()

## Build the regulon db object
e_coli_regulondb <-
    regulondb(
        database_conn = regulondb_conn,
        organism = "E.coli",
        database_version = "1",
        genome_version = "1"
    )

## Get the araC regulators
araC_regulation <-
    get_gene_regulators(
        e_coli_regulondb,
        genes = c("araC"),
        format = "multirow",
        output.type = "TF"
    )

## Summarize the araC regulation
get_regulatory_summary(e_coli_regulondb, araC_regulation)

## Retrieve summary of genes 'araC' and 'modB'
get_regulatory_summary(e_coli_regulondb,
    gene_regulators = c("araC", "modB")
)

## Obtain the summary for 'ECK120000050' and 'modB'
get_regulatory_summary(e_coli_regulondb,
    gene_regulators = c("ECK120000050", "modB")
)
}
\author{
Carmina Barberena Jonas, Jesús Emiliano Sotelo Fonseca,
José Alquicira Hernández, Joselyn Chávez
}
\keyword{networks,}
\keyword{regulation}
\keyword{retrieval,}
\keyword{summary,}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/existing_intervals.R
\name{existing_intervals}
\alias{existing_intervals}
\title{Constructs a particular logical condition to query database}
\usage{
existing_intervals(filters, interval, operator, partialmatch)
}
\arguments{
\item{filters}{List of filters to be used. The names should correspond to
the attribute and the values correspond to the condition for selection.}

\item{interval}{the filters with values considered as interval.}

\item{operator}{A string indicading if all the filters (AND) or some of
them (OR) should be met.}

\item{partialmatch}{name of the condition(s) with a string pattern for full
or partial match in the query.}
}
\value{
A \code{character(1)} with the sql logical condition to query the dataset.
}
\description{
Given a list of filters, this function builds a logical
condition to query database using intervals.
The output is used in \code{\link[=build_condition]{build_condition()}}.
}
\examples{

## Build the SQL query for existing interval partial matches for ara
existing_intervals(
    filters = list(
        name = "ara",
        strand = "for",
        posright = c("2000", "40000")
    ),
    interval = c("posright"),
    operator = "AND",
    partialmatch = c("name", "strand")
)
}
\author{
Carmina Barberena Jonás, Jesús Emiliano Sotelo Fonseca,
José Alquicira Hernández, Joselyn Chávez
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/list_attributes.R
\name{list_attributes}
\alias{list_attributes}
\title{List attributes/fields from a dataset/table}
\usage{
list_attributes(regulondb, dataset)
}
\arguments{
\item{regulondb}{A \code{\link[=regulondb]{regulondb()}} object.}

\item{dataset}{Dataset of interest. The name should correspond to a table of
the database.}
}
\value{
A character vector with the field names.
}
\description{
List all attributes and their description of a dataset from
RegulonDB. The result of this function may
be used as parameter 'values' in \code{\link[=list_attributes]{list_attributes()}} function.
}
\examples{
## Connect to the RegulonDB database if necessary
if (!exists("regulondb_conn")) regulondb_conn <- connect_database()

## Build the regulon db object
e_coli_regulondb <-
    regulondb(
        database_conn = regulondb_conn,
        organism = "E.coli",
        database_version = "1",
        genome_version = "1"
    )

## List the transcription factor attributes
list_attributes(e_coli_regulondb, "TF")

## List the operon attributes
list_attributes(e_coli_regulondb, "OPERON")
}
\author{
Carmina Barberena Jonás, Jesús Emiliano Sotelo Fonseca,
José Alquicira Hernández, Joselyn Chavez
}
\keyword{attributes}
\keyword{data}
\keyword{retrieval,}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_regulatory_network.R
\name{get_regulatory_network}
\alias{get_regulatory_network}
\title{Return complete regulatory network.}
\usage{
get_regulatory_network(
  regulondb,
  regulator = NULL,
  type = "TF-GENE",
  cytograph = FALSE
)
}
\arguments{
\item{regulondb}{A \code{\link[=regulondb]{regulondb()}} object.}

\item{regulator}{Name of TF or gene that acts as regulator. If \code{NULL}, the
function retrieves all existent networks in the regulonDB.}

\item{type}{"TF-GENE", "TF-TF", "GENE-GENE"}

\item{cytograph}{If TRUE, displays network in Cytoscape. This option
requires previous instalation and launch of Cytoscape.}
}
\value{
A \link[=regulondb_result-class]{regulondb_result} object.
}
\description{
This function retrieves all the regulation networks in
regulonDB between TF-TF, GENE-GENE or TF-GENE depending on the parameter
'type'.
}
\examples{

## Connect to the RegulonDB database if necessary
if (!exists("regulondb_conn")) regulondb_conn <- connect_database()

## Build the regulon db object
e_coli_regulondb <-
    regulondb(
        database_conn = regulondb_conn,
        organism = "E.coli",
        database_version = "1",
        genome_version = "1"
    )

## Retrieve regulation of 'araC'
get_regulatory_network(e_coli_regulondb,
    regulator = "AraC",
    type = "TF-GENE"
)

## Retrieve all GENE-GENE networks
get_regulatory_network(e_coli_regulondb, type = "GENE-GENE")

## Retrieve TF-GENE network of AraC and display in Cytoscape
## Note that Cytospace needs to be open for this to work
cytoscape_present <- try(RCy3::cytoscapePing(), silent = TRUE)
if (!is(cytoscape_present, "try-error")) {
    get_regulatory_network(
        e_coli_regulondb,
        regulator = "AraC",
        type = "TF-GENE",
        cytograph = TRUE
    )
}
}
\author{
Carmina Barberena Jonas, Jesús Emiliano Sotelo Fonseca,
José Alquicira Hernández, Joselyn Chávez
}
\keyword{TF,}
\keyword{networks,}
\keyword{regulation}
\keyword{retrieval,}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/guess_id.R
\name{guess_id}
\alias{guess_id}
\title{Guess gene id type}
\usage{
guess_id(gene, regulondb)
}
\arguments{
\item{gene}{Character vector of gene identifiers (id, name, bnumber or gi).}

\item{regulondb}{A \code{\link[=regulondb]{regulondb()}} object.}
}
\value{
A \code{character(1)} vector with the name column guessed value.
}
\description{
Given a gene identifier, return the most likely gene_id type.
}
\examples{
## Connect to the RegulonDB database if necessary
if (!exists("regulondb_conn")) regulondb_conn <- connect_database()

## Build the regulon db object
e_coli_regulondb <-
    regulondb(
        database_conn = regulondb_conn,
        organism = "E.coli",
        database_version = "1",
        genome_version = "1"
    )

## Lists all available identifiers for "araC"
## Guess name
guess_id("araC", e_coli_regulondb)

## Guess id
guess_id("ECK120000050", e_coli_regulondb)

## Guess bnumber
guess_id("b0064", e_coli_regulondb)
}
\author{
Jesús Emiliano Sotelo Fonseca
}
\keyword{bnumber,}
\keyword{geneid,}
\keyword{gi,}
\keyword{synonyms}
